CATMULL_SHIFT equ 8
ROUND equ 16


triangle_shd:
;  procedure draws shadowed triangle - saturated substraction in
;  every pixel ----------------------------------------------------
;  ----------------in - eax - x1 shl 16 + y1 ----------------------
;  -------------------- ebx - x2 shl 16 + y2 ----------------------
;  -------------------- ecx - x3 shl 16 + y3 ----------------------
;  -------------------- edx - shadow substracted color 0x00RRGGBB--
;  -------------------- edi - pointer to screen buffer-------------
; --------------------- esi - shadow buffer -----------------------


.col_sh equ dword[ebp-4]
.x1	equ word[ebp-6]
.y1	equ word[ebp-8]
.x2	equ word[ebp-10]
.y2	equ word[ebp-12]
.x3	equ word[ebp-14]
.y3	equ word[ebp-16]

.dx12	equ dword[ebp-20]
.dx13	equ dword[ebp-24]
.dx23	equ dword[ebp-28]

	mov	ebp,esp

	push	edx	       ; store edx in variable .col
      .sort2:
	cmp	ax,bx
	jle	.sort1
	xchg	eax,ebx
      .sort1:
	cmp	bx,cx
	jle	.sort3
	xchg	ebx,ecx
	jmp	.sort2
      .sort3:
	push	eax	       ; store triangle coordinates in user friendly variables
	push	ebx
	push	ecx
	mov	 edx,80008000h	; eax,ebx,ecx are ANDd together into edx which means that
	and	 edx,ebx	; if *all* of them are negative a sign flag is raised
	and	 edx,ecx
	and	 edx,eax
	test	 edx,80008000h	; Check both X&Y at once
	jne	 .ft_loop2_end
    ;	 sub	 esp,64 ;52+12

	mov	bx,.y2	     ; calc delta 12
	sub	bx,.y1
	jnz	.ft_dx12_make
     ;	 mov	 .dx12,0
	push	dword 0
	jmp	.ft_dx12_done
   .ft_dx12_make:

	mov	ax,.x2	     ; version with two div
	sub	ax,.x1
	cwde
	movsx	ebx,bx

	shl	eax,ROUND
	cdq
	idiv	ebx
    ;	 mov	 .dx12,eax
	push	 eax
  .ft_dx12_done:
	mov	bx,.y3	     ; calc delta 13
	sub	bx,.y1
	jnz	.ft_dx13_make
      ;
   ;   mov     .dx13,0
       push    dword 0
	jmp	.ft_dx13_done
   .ft_dx13_make:

	mov	ax,.x3
	sub	ax,.x1
	cwde
	movsx	ebx,bx
	shl	eax,ROUND
	cdq
	idiv	ebx
      ;  mov	 .dx13,eax
	push	eax
    .ft_dx13_done:
	mov	bx,.y3	     ; calc delta 23
	sub	bx,.y2
	jnz	.gt_dx23_make
      ;  mov	 .dx23,0
	push   dword 0
	jmp	.gt_dx23_done
   .gt_dx23_make:
	mov	ax,.x3
	sub	ax,.x2
	cwde
	movsx	ebx,bx
	shl	eax,ROUND
	cdq
	idiv	ebx
      ;  mov	 .dx23,eax
	push	eax
    .gt_dx23_done:
	movsx	eax,.x1
	shl	eax,ROUND    ; eax - x1
	mov	ebx,eax      ; ebx - x2

	mov	cx,.y1
	cmp	cx,.y2
	jge	.ft_loop1_end
     .ft_loop1:


	pushad

	push	.col_sh
	push	cx	    ; y
	sar	ebx,ROUND
	push	bx	    ; x2
	sar	eax,ROUND
	push	ax	    ; x1


	call	shadow_line

	popad

	add	eax,.dx13
	add	ebx,.dx12


	inc	cx
	cmp	cx,.y2
	jl     .ft_loop1



    .ft_loop1_end:
	mov	cx,.y2
	cmp	cx,.y3
	jge	.ft_loop2_end

	movsx	ebx,.x2
	shl	ebx,ROUND


     .ft_loop2:
	pushad

	push	.col_sh
	push	cx
	sar	ebx,ROUND
	push	bx
	sar	eax,ROUND
	push	ax	    ; x1


	call	shadow_line

	popad

	add	eax,.dx13
	add	ebx,.dx23


	inc	cx
	cmp	cx,.y3
	jl	.ft_loop2
     .ft_loop2_end:

	mov esp,ebp
ret

shadow_line:
;----------------
;-------------in edi - pointer to screen buffer ----------------------------------
.x1 equ word  [ebp+4]
.x2 equ word  [ebp+6]
.y  equ word  [ebp+8]
.col equ dword [ebp+10]




     mov	ebp,esp
     mov	ax,.y
     or 	ax,ax
     jle	.fl_quit
     mov	bx,[yres_var]
   ;  dec	 bx
     cmp	ax,bx  ;SIZE_Y-1
     jge	.fl_quit


     mov	ax,.x1
     cmp	ax,.x2
     je 	.fl_quit
     jl 	.fl_ok

     xchg	ax,.x2
     mov	.x1,ax
   .fl_ok:
     mov	 ax,[xres_var]
     cmp	.x1,ax
     jge	.fl_quit
     cmp	.x2,0
     jle	.fl_quit


     cmp	.x1,0
     jge	@f
   ;  movsx	 ebx,.x1
   ;  neg	 ebx
   ;  imul	 ebx
   ;  add	 .z1,eax
     mov	.x1,0
    @@:
     mov	 ax,[xres_var]
     cmp	.x2,ax
     jl 	@f
     mov	.x2,ax
    @@:
     movzx	edx,[xres_var]
     movzx	eax,.y
     mul	edx		     ; edi = edi + (SIZE_X * y + x1)*4
     movzx	edx,.x1
     add	eax,edx
     add	esi,eax
     shl	eax,2
     add	edi,eax

     mov	cx,.x2
     sub	cx,.x1

     movzx	ecx,cx

     movd	xmm0,.col
   ;  pshufd	 xmm0,xmm0,0
   ;  shr	 ecx,1
   ;  jnc	 @f
   ;  movd	 xmm1,[edi]
   ;  psubusb	 xmm1,xmm0
   ;  movd	 [edi],xmm1
   ;  add	  edi,4
   ;  jecxz	 .fl_quit
   .ddraw:
     cmp       byte[esi],0
     jne       @f
     movd      xmm1,[edi]
     psubusb	xmm1,xmm0
     movd      [edi],xmm1
     mov       byte[esi],1
    @@:
     add	edi,4
     add	esi,1
     loop      .ddraw

   .fl_quit:

     mov   esp,ebp
ret 10
