
;  rotary about arbitrary vector implemented by Maciej Guba,
;  macgub3@wp.pl , http://macgub.hekko.pl
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desired matrix
make_arbitrary_mx:
 .nx	  equ dword[ebx]
 .ny	  equ dword[ebx+4]
 .nz	  equ dword[ebx+8]
 .sinus   equ dword[esi]
 .cosinus equ dword[esi+4]
 fninit
 fld	dword[ebx]
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus ; dword[esi]
 faddp
 fstp	dword[edi]

 fld	.nx
 fmul	.ny
 fld	.cosinus
 fchs
 fld1
 faddp
 fmulp
 fld	.nz ;dword[ebx+8]
 fmul	.sinus	;dword[esi]
; fchs
 faddp
 fstp	dword[edi+4]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+8]

 fld	.nx
 fmul	.ny
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nz
 fchs
 faddp
 fstp	dword[edi+12]

 fld	.ny
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus
 faddp
 fstp	dword[edi+16]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.sinus
 fmul	.nx
; fchs
 faddp
 fstp	dword[edi+20]

 fld	.nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	.sinus
; fchs
 faddp
 fstp	dword[edi+24]

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.nx
 fmul	.sinus
 fchs
 faddp
 fstp	dword[edi+28]

 fld	.nz
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
ret




save_object:	   ; make_object - rotate around vector, do points list
		   ; do triangles list
   pushad
  .counter	    equ dword [ebp-4]
  .rot_points_ptr   equ dword [ebp-8]
  .one_deg	    equ dword [ebp-12]
  .steps	    equ dword [ebp-16]
  .segments_counter equ dword [ebp-20]
  .Bpoints_ptr	    equ dword [ebp-24]	    ; pointer to actual non rotated curve segment
  .seg_tri_counter  equ dword [ebp-28]
  .last_tri_counter equ dword [ebp-32]
  .seg_deg_sin_x    equ dword [ebp-36]
  .seg_deg_cos_x    equ dword [ebp-40]
  .seg_deg_sin_y    equ dword [ebp-44]
  .seg_deg_cos_y    equ dword [ebp-48]
  .seg_deg_sin_z    equ dword [ebp-52]
  .seg_deg_cos_z    equ dword [ebp-56]
  .matrix	    equ       [ebp-92]
 ; .center	     equ       [ebp-108]
   mov	ebp,esp
   sub	esp,128

   mov	esi,Bx1_axis
   mov	edi,Bx2_axis
   mov	ebx,Bx_axis_v
   call make_vector_r
   mov	edi,Bx_axis_v
   call normalize_vector
   xor	eax,eax
   fninit
   fldpi
   fadd  st,st0
   mov	 .steps,BSTEPS
   fidiv .steps
   fstp  .one_deg


 ;  add translate vector from segment_add struct to every
 ;  Bezier curve segment
if 0
   xor	    eax,eax
   mov	    esi,Bpoints
 .next_seg:
   mov	    ecx,BSTEPS*BSTEPS
   mov	    ebx,eax
   shl	    ebx,2
   lea	    ebx,[ebx*3]
   movdqu  xmm1,[segments_add+ebx]
   cvtdq2ps xmm1,xmm1
 @@:
   movups  xmm0,[esi]
   addps   xmm0,xmm1
   movlps  [esi],xmm0
   movhlps xmm0,xmm0
   movss   [esi+8],xmm0
   add	   esi,12
   sub	   ecx,1
   jnz	   @b
   add	   eax,1
   cmp	   eax,BSEGMENTS
   jnz	   .next_seg
end if
   mov	.rot_points_ptr,Bpoints_r      ; points describing rotated solid
   mov	.Bpoints_ptr,Bpoints	       ; pointer to current non rotated curve segment
   mov	.segments_counter,0

 .loop2:

   xor	 eax,eax
 .loop1:

   push  eax
   mov	 ebx,Bx_axis_v
   mov	 edi,Bmatrix
   mov	 .counter,eax	     ; degrees counter
   fld	 .one_deg
   fimul .counter
   fsincos
   fstp  [Bsinus]
   fstp  [Bcosinus]
   lea	 esi,[Bsinus]
   call  make_arbitrary_mx

   mov	 ebx,Bmatrix
   mov	 ecx,BSTEPS   ;[maxcountervar]

   mov	 esi,.Bpoints_ptr
   mov	 edi,.rot_points_ptr
   pushad
   call  mul_matrix
   popad
   pop	 eax

   add	 .rot_points_ptr,BSTEPS*12
   add	 eax,1
   cmp	 eax,BROTARY_STEPS ;;+2  ;;	   <-----
   jne	 .loop1

;   mov   eax,.segments_counter
 ;  rotate individual each segment of bezier solid
;   cmp   al,[current_seg]

;   jne  .skipp

if 1

; rotate bezier curve segment according to segment_rotary struct
   fninit
 ;  fldpi
 ;  fidiv [i180]
   fld	 [one_deg]
   fld	 st
   mov	 eax,.segments_counter
   shl	 eax,2
   lea	 eax,[eax*3]
   fimul dword[segments_rotary+eax]   ; x
   fsincos
   fstp  .seg_deg_sin_x
   fstp  .seg_deg_cos_x
   fld	 st
   fimul dword[segments_rotary+4+eax] ; y
   fsincos
   fstp  .seg_deg_sin_y
   fstp  .seg_deg_cos_y
   fimul dword[segments_rotary+8+eax] ; z
   fsincos
   fstp  .seg_deg_sin_z
   fstp  .seg_deg_cos_z

   mov	 esi,.rot_points_ptr
   sub	 esi,(BSTEPS*(BSTEPS))*12
   ; find center point of segment
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movups   [cur_seg_max],xmm0
;   movups   [cur_seg_min],xmm1

   subps  xmm0,xmm1
   cvtsi2ss xmm2,[i2]
   shufps xmm2,xmm2,0
   divps  xmm0,xmm2
   addps  xmm0,xmm1  ; xmm0 - center of segment
   movups [cur_seg_center],xmm0

   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  ecx,BSTEPS*(BSTEPS)
 @@:
   movups  xmm2,[esi]
   subps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b

   pushad
   push   .seg_deg_sin_x
   push   .seg_deg_cos_x
   push   .seg_deg_sin_y
   push   .seg_deg_cos_y
   push   .seg_deg_sin_z
   push   .seg_deg_cos_z
   mov	  edi,.matrix
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   ; ..and rotate

   push   ebp
   mov	  ebx,.matrix
   mov	  ecx,BSTEPS*BSTEPS
   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  edi,esi
   call   rotary
   pop	  ebp

   movups xmm0,[cur_seg_center]
   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  ecx,BSTEPS*BSTEPS

   ; .. and add center point after rotary

 @@:
   movups  xmm2,[esi]
   addps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b


end if

   add	 .Bpoints_ptr,BSTEPS * 12
   add	 .segments_counter,1
   cmp	 .segments_counter,BSEGMENTS
   jnz	 .loop2

 ;  add translate vector from segment_add struct to every
 ;  Bezier curve segment
if 0
   xor	    eax,eax
   mov	    esi,Bpoints_r
 .next_seg:
   mov	    ecx,BSTEPS*BSTEPS
   mov	    ebx,eax
   shl	    ebx,2
   lea	    ebx,[ebx*3]
   movdqu   xmm1,[segments_add+ebx]
   cvtdq2ps xmm1,xmm1
 @@:
   movups   xmm0,[esi]
   addps    xmm0,xmm1
   movlps   [esi],xmm0
   movhlps  xmm0,xmm0
   movss    [esi+8],xmm0
   add	    esi,12
   sub	    ecx,1
   jnz	    @b
   add	    eax,1
   cmp	    eax,BSEGMENTS
   jnz	    .next_seg
end if


   ; do triangles list

   mov	  esi,Btriangles
   mov	  [Btriangles_count],0	   ; do triangles list
   mov	  .seg_tri_counter,0
 .loop_seg_tri:
   mov	  edx,.seg_tri_counter
   mov	  eax,BSTEPS*BROTARY_STEPS ;(BROTARY_STEPS-1) ;
   mul	  edx

   mov	  edx,(BSTEPS-1) ;;;-2); 0000000 * BSEGMENTS	   ;	 <------


   mov	  ebx,eax
  .oop2:
   mov	  ecx,BSTEPS-1
  @@:
   mov	  ax,bx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+6],ax
   mov	  [esi+4],ax
   add	  ax,BSTEPS-1
   mov	  [esi+2],ax
   mov	  [esi+8],ax
   inc	  ax
   mov	  [esi+10],ax
   add	  esi,12
   inc	  bx
   add	  [Btriangles_count],2
   loop   @b
   add	  bx,1

   dec	  dx
   cmp	  dx,0
   jnz	  .oop2


   mov	 eax, .seg_tri_counter
   add	 eax,1
   mov	 ecx,BSTEPS * BSTEPS
   mul	 ecx
   mov	 ecx,eax
   sub	 ecx,BSTEPS; - 1
   mov	 ebx,eax
   sub	 ebx,BSTEPS * BSTEPS
   mov	 .last_tri_counter,ebx
   add	 .last_tri_counter,BSTEPS - 1
 @@:
   mov	  eax,ebx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+2],ax
   mov	  [esi+4],cx
   mov	  [esi+6],cx
   inc	  cx
   mov	  [esi+8],ax
   mov	  [esi+10],cx
   add	  esi,12
   add	  [Btriangles_count],2
   inc	  ebx
   cmp	  ebx,.last_tri_counter
   jne	  @b


   add	 .seg_tri_counter,1
   cmp	 .seg_tri_counter,BSEGMENTS
   jnz	 .loop_seg_tri

   mov	 [esi],dword -1





   mov	 esi,Btriangles
   mov	 edi,[triangles_ptr]
   cld
   mov	 ecx,[Btriangles_count]
 @@:
   movsd
   movsw
   loop @b

   mov	dword[edi+4],-1



    mov eax,BROTARY_STEPS*BSTEPS*BSEGMENTS
    mov [points_count_var],ax




   mov	 esi,Bpoints_r
   mov	 edi,[points_r_ptr]
   movzx ecx,[points_count_var]
   lea	 ecx,[ecx*3]
   rep	 movsd
   movsd


   mov	ebx, [Btriangles_count]
   mov	[triangles_count_var],bx


    pushad
  ;  pushad
    push   dword [points_r_ptr]
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    movss  [maxscaleseg],xmm7
    movups [allsegcenter],xmm0
    pushad





 if 0
    mov   ebx,BSTEPS*BSTEPS*12
    movzx eax,[current_seg]
    mul   ebx
    mov   esi,eax
    add   esi,[points_r_ptr]
    mov   ecx,BSTEPS*BSTEPS
    movups   xmm3,[current_seg_add] ; x,y,z
    movss    xmm4,[scale]
    shufps   xmm4,xmm4,0
    cvtdq2ps xmm3,xmm3
    divps    xmm3,xmm4
  @@:
    movups  xmm0,[esi]
    addps   xmm0,xmm3
    movlps  [esi],xmm0
    movhlps xmm0,xmm0
    movss   [esi+8],xmm0
    add     esi,12
    loop    @b
end if
if 0
    movups   xmm0,[cur_seg_max]
    movups   xmm1,[center_scale]
    subps    xmm0,xmm1
    movss    xmm3,[max_scale]
    shufps   xmm3,xmm3,0
    divps    xmm0,xmm3
    movlps   [cur_seg_max],xmm0
    movhlps  xmm0,xmm0
    movss    [cur_seg_max+8],xmm0

    movups   xmm0,[cur_seg_min]
    subps    xmm0,xmm1
    divps    xmm0,xmm3
    movups   [cur_seg_min],xmm0
end if
    popad

    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords

    mov   esp,ebp
    popad
ret


save3ds:
    pushad
    mov   ebp,esp

    mov edi,Bfile_buffer
    mov [edi],word 4d4dh
    add edi,6
    mov [edi],word 3d3dh
    add edi,6
    mov [edi],word 4000h
    add edi,6
    mov [edi],byte 0
    inc edi
    mov [edi],word 4100h     ;	  [global_points_counter]
    add  edi,6
    mov [edi],word 4110h
    movzx ecx,[points_count_var]

    mov edx,ecx
    mov [edi+6],cx
    add edi,8
    mov esi,[points_r_ptr]   ;[points_rotated_ptr]
    xor ebx,ebx
    lea ecx,[ecx*3]
@@:
    rep movsd
    mov  [edi],word 4120h
    movzx ecx,[triangles_count_var]
    mov  [edi+6],cx
    add  edi,8
    mov  esi,[triangles_ptr]
    cld
 @@:
    movsd
    movsw
    add  edi,2
    loop @b

    sub  edi,Bfile_buffer
    mov  [Bfile_buffer+2],edi
    mov  [Bfile_size],edi
    invoke  CreateFile,Bfile_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
     mov  [Bfile_handle],eax
    invoke  WriteFile,eax,Bfile_buffer,[Bfile_size],Bbyteswritten, 0
    invoke  CloseHandle,[Bfile_handle]

    mov   esp,ebp
    popad
ret

save_pipe:	  ; Make object (Bezier pipe) - make vector using every
		  ; pair of points, set third point with changed z coord.
		  ; (radius lenght), rotate BSTEPS times and do so with
		  ; every pair of points; do points list
		  ; do triangles list.

   pushad

  .counter	       equ   word [ebp-4]
  .rot_points_ptr      equ   dword[ebp-8]
  .one_deg	       equ   dword[ebp-12]
  .steps	       equ   word [ebp-16]
  .cur_vector	       equ   dword[ebp-28]
  .3rd_point_z	       equ   dword[ebp-32]
  .3rd_point_y	       equ   dword[ebp-36]
  .cur_point	       equ   dword[ebp-40]
  .radius	       equ   dword[ebp-44]
  .b_curve_points_ptr  equ   dword[ebp-48]
  .counter2	       equ   dword[ebp-52]
  .additionY	       equ   dword[ebp-56]
  .additionX	       equ   [ebp-60]
  .cur_seg	       equ   dword[ebp-64]
  .seg_deg_sin_x       equ   dword[ebp-68]
  .seg_deg_cos_x       equ   dword[ebp-72]
  .seg_deg_sin_y       equ   dword[ebp-76]
  .seg_deg_cos_y       equ   dword[ebp-80]
  .seg_deg_sin_z       equ   dword[ebp-84]
  .seg_deg_cos_z       equ   dword[ebp-88]
  .cur_seg_adres       equ   dword[ebp-92]

   mov	ebp,esp
   sub	esp,128

   mov	esi,Bx1_axis	  ; radius = lenght of axis
   mov	edi,Bx2_axis
   lea	ebx,.cur_vector
   call make_vector_r

   lea	edi,.cur_vector
   fninit
   fld	dword [edi]
   fmul st,st0
   fld	dword [edi+4]
   fmul st,st0
   fld	dword [edi+8]
   fmul st,st0
   faddp
   faddp
   fsqrt
   fstp .radius

   fldpi			  ; calc one deg
   fadd  st,st0
   mov	 .steps,BSTEPS
   fidiv .steps
   fstp  .one_deg

   mov	.rot_points_ptr,Bpoints_r
   mov	.b_curve_points_ptr,Bpoints

   xor	ecx,ecx
 .loop_segment:
   push ecx

   mov	.counter2,1

 .loop1:
   mov	.counter,1
   mov	esi,.b_curve_points_ptr
   lea	edi,[esi+12]
   lea	ebx,.cur_vector
   call make_vector_r
   lea	edi,.cur_vector
   call normalize_vector


   mov	 esi,.b_curve_points_ptr
   lea	 edi,.cur_point
   fld	 dword[esi]
   fst	 dword .additionX
   fadd  dword[esi+12]
   fidiv [i2]
   fsub  dword[esi]
   fstp  dword[edi]
   fld	 dword[esi+4]
   fst	 .additionY
   fadd  dword[esi+16]
   fidiv [i2]
   fsub  dword[esi+4]
   fstp  dword[edi+4]
   fld	 .radius
   fstp  dword[edi+8]



 .loop2:
   lea	 ebx,.cur_vector	     ; make rotary matrix
   mov	 edi,Bmatrix
   fld	 .one_deg
   fimul .counter
   fsincos
   fstp  [Bsinus]
   fstp  [Bcosinus]
   lea	 esi,[Bsinus]
   call  make_arbitrary_mx

   mov	 ebx,Bmatrix
   mov	 ecx,1
   mov	 edi,.rot_points_ptr
   lea	 esi,.cur_point        ;.b_curve_points_ptr
   pushad
   call  mul_matrix
   popad

   mov	  edi,.rot_points_ptr
   movlps xmm0,[edi]
   movlps xmm1,.additionX
   addps  xmm0,xmm1
   movlps [edi],xmm0

   add	 .rot_points_ptr,12
   inc	 .counter
   cmp	 .counter,BSTEPS + 1
   jnz	 .loop2

   add	 .b_curve_points_ptr,12
   inc	 .counter2
   cmp	 .counter2,BSTEPS + 1 ; +2	000000000000000000000000000
   jnz	 .loop1
   pop	 ecx
   add	 ecx,1
   cmp	 ecx,BSEGMENTS
   jne	 .loop_segment


if 1

; rotate bezier curve pipe segment according to segment_rotary struct
   mov	 .cur_seg,0
   fninit
 .next_seg:
 ;  fldpi
 ;  fidiv [i180]
   fld	 [one_deg]
   fld	 st
   mov	 eax,.cur_seg
   shl	 eax,2
   lea	 eax,[eax*3]
   fimul dword[segments_rotary+eax]   ; x
   fsincos
   fstp  .seg_deg_sin_x
   fstp  .seg_deg_cos_x
   fld	 st
   fimul dword[segments_rotary+4+eax] ; y
   fsincos
   fstp  .seg_deg_sin_y
   fstp  .seg_deg_cos_y
   fimul dword[segments_rotary+8+eax] ; z
   fsincos
   fstp  .seg_deg_sin_z
   fstp  .seg_deg_cos_z


   mov	 esi,.cur_seg
   mov	 eax,BSTEPS*BSTEPS*12
   mul	 esi
   add	 eax,Bpoints_r
   mov	 .cur_seg_adres,eax
   mov	 esi,eax
   ; find center point of segment pipe
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movups   [cur_seg_max],xmm0
;   movups   [cur_seg_min],xmm1

   subps  xmm0,xmm1
   cvtsi2ss xmm2,[i2]
   shufps xmm2,xmm2,0
   divps  xmm0,xmm2
   addps  xmm0,xmm1  ; xmm0 - center of segment
   movups [cur_seg_center],xmm0

   ; substract pipe segment center
   mov	  esi,.cur_seg_adres
   mov	  ecx,BSTEPS*(BSTEPS)
 @@:
   movups  xmm2,[esi]
   subps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b

   pushad
   push   .seg_deg_sin_x
   push   .seg_deg_cos_x
   push   .seg_deg_sin_y
   push   .seg_deg_cos_y
   push   .seg_deg_sin_z
   push   .seg_deg_cos_z
   mov	  edi,Bmatrix
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   ; ..and rotate

   push   ebp
   mov	  ebx,Bmatrix
   mov	  ecx,BSTEPS*BSTEPS
   mov	  esi,.cur_seg_adres
   mov	  edi,esi
   call   rotary
   pop	  ebp

   movups xmm0,[cur_seg_center]
   mov	  esi,.cur_seg_adres
   mov	  ecx,BSTEPS*BSTEPS

   ; .. and add center point after rotary

 @@:
   movups  xmm2,[esi]
   addps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b

   add	  .cur_seg,1
   cmp	  .cur_seg,BSEGMENTS
   jne	  .next_seg


end if




	     ; do triangles list
   mov	esi,Btriangles
   mov	[Btriangles_count],0
   mov	.counter2,0	     ;segments counter
 .loop_seg_tri:
   mov	 eax,.counter2
   mov	 ecx,BSTEPS * BSTEPS
   mul	 ecx
   mov	 edx,BSTEPS - 2
   sub	 edx,.counter2
 .oop:
   mov	 ecx,BSTEPS - 1
 @@:
   mov	[esi],ax
   mov	bx,ax
   inc	ax
   mov	[esi+4],ax
   add	bx,BSTEPS
   mov	[esi+2],bx
   mov	[esi+6],bx
   inc	bx
   mov	[esi+8],bx
   mov	[esi+10],ax
   add	esi,12
   add	[Btriangles_count],2
   loop @b

   inc	eax
   dec	edx
   jnz	.oop

if 1
   ;last strip of triangles
   mov	 eax,BSTEPS * BSTEPS
   mul	 .counter2
   mov	 ecx,BSTEPS-2
   sub	 ecx,.counter2
 @@:
   mov	 [esi],ax
   mov	 bx,ax
   add	 bx,BSTEPS-1
   mov	 [esi+2],bx
   mov	 [esi+8],bx
   inc	 bx
   mov	 [esi+4],bx
   mov	 [esi+6],bx
   add	 bx,BSTEPS-1
;   add  ax,BSTEPS*2-1
   mov	 [esi+10],bx ;ax
   add	 esi,12
   add	 [Btriangles_count],2
   add	 eax,BSTEPS
   loop  @b
end if
   add	.counter2,1
   cmp	.counter2,BSEGMENTS  ;[licznik_debug],1  ;BSEGMENTS+1
   jne	.loop_seg_tri



   mov	 esi,Btriangles 	   ; copy triangles list
   mov	 edi,[triangles_ptr]
   cld
   mov	 ecx,[Btriangles_count]
 @@:
   movsd
   movsw
   loop @b
   mov	dword[edi+4],-1




    mov ecx,[global_points_counter]
    mov eax,BSTEPS - 1	      ;000000000000000000000000000
    mul ecx
    mov [points_count_var],ax

   movzx eax,ax
   cdq
   mov	 ecx,BSEGMENTS
   div	 ecx
   mov	 [rot_pipe_points_number],eax	   ; init this variable



   mov	 esi,Bpoints_r
   mov	 edi,[points_r_ptr]
   movzx ecx,[points_count_var]
   lea	 ecx,[ecx*3]
   rep	 movsd
   movsd



   mov	ebx, [Btriangles_count]
   mov	[triangles_count_var],bx

    pushad
    push   dword [points_r_ptr]
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
;    movss  [maxscaleseg
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords

    mov   esp,ebp
    popad
ret


save_pipe_rot_solid:


  .rot_points_ptr   equ dword [ebp-8]
  .one_deg	    equ dword [ebp-12]
  .steps	    equ dword [ebp-16]
  .segments_counter equ dword [ebp-20]
  .Bpoints_ptr	    equ dword [ebp-24]	    ; pointer to actual non rotated curve segment
  .seg_tri_counter  equ dword [ebp-28]
  .last_tri_counter equ dword [ebp-32]
  .seg_deg_sin_x    equ dword [ebp-36]
  .seg_deg_cos_x    equ dword [ebp-40]
  .seg_deg_sin_y    equ dword [ebp-44]
  .seg_deg_cos_y    equ dword [ebp-48]
  .seg_deg_sin_z    equ dword [ebp-52]
  .seg_deg_cos_z    equ dword [ebp-56]
  .matrix	    equ       [ebp-92]


  .cur_vector	       equ   dword[ebp-96]
  .3rd_point_z	       equ   dword[ebp-100]
  .3rd_point_y	       equ   dword[ebp-104]
  .cur_point	       equ   dword[ebp-108]
  .radius	       equ   dword[ebp-112]
  .b_curve_points_ptr  equ   dword[ebp-116]
  .counter2	       equ   dword[ebp-120]
  .additionY	       equ   dword[ebp-124]
  .additionX	       equ   [ebp-128]
  .cur_seg	       equ   dword[ebp-132]
  .cur_seg_adres       equ   dword[ebp-136]
  .counter	       equ   dword[ebp-140]


  pushad
  mov  ebp,esp
  sub  esp,255
  mov  eax,BPIPES
  cmp  eax,0
  je   .skip_pipes
;if  BPIPES > 0
;  je	.skip_pipes
  ; at first draw pipes
   mov	esi,Bx1_axis	  ; radius = lenght of axis
   mov	edi,Bx2_axis
   lea	ebx,.cur_vector
   call make_vector_r

   lea	edi,.cur_vector
   fninit
   fld	dword [edi]
   fmul st,st0
   fld	dword [edi+4]
   fmul st,st0
   fld	dword [edi+8]
   fmul st,st0
   faddp
   faddp
   fsqrt
   fstp .radius

   fldpi			  ; calc one deg
   fadd  st,st0
   mov	 .steps,BSTEPS
   fidiv .steps
   fstp  .one_deg

   mov	.rot_points_ptr,Bpoints_r
   mov	.b_curve_points_ptr,Bpoints

   xor	ecx,ecx
 .loop_segment:
   push ecx

   mov	.counter2,1

 .loop1:
   mov	.counter,1
   mov	esi,.b_curve_points_ptr
   lea	edi,[esi+12]
   lea	ebx,.cur_vector
   call make_vector_r
   lea	edi,.cur_vector
   call normalize_vector


   mov	 esi,.b_curve_points_ptr
   lea	 edi,.cur_point
   fld	 dword[esi]
   fst	 dword .additionX
   fadd  dword[esi+12]
   fidiv [i2]
   fsub  dword[esi]
   fstp  dword[edi]
   fld	 dword[esi+4]
   fst	 .additionY
   fadd  dword[esi+16]
   fidiv [i2]
   fsub  dword[esi+4]
   fstp  dword[edi+4]
   fld	 .radius
   fstp  dword[edi+8]



 .loop2:
   lea	 ebx,.cur_vector	     ; make rotary matrix
   mov	 edi,Bmatrix
   fld	 .one_deg
   fimul .counter
   fsincos
   fstp  [Bsinus]
   fstp  [Bcosinus]
   lea	 esi,[Bsinus]
   call  make_arbitrary_mx

   mov	 ebx,Bmatrix
   mov	 ecx,1
   mov	 edi,.rot_points_ptr
   lea	 esi,.cur_point        ;.b_curve_points_ptr
   pushad
   call  mul_matrix
   popad

   mov	  edi,.rot_points_ptr
   movlps xmm0,[edi]
   movlps xmm1,.additionX
   addps  xmm0,xmm1
   movlps [edi],xmm0

   add	 .rot_points_ptr,12
   inc	 .counter
   cmp	 .counter,BSTEPS + 1
   jnz	 .loop2

   add	 .b_curve_points_ptr,12
   inc	 .counter2
   cmp	 .counter2,BSTEPS + 1 ; +2	000000000000000000000000000
   jnz	 .loop1
   pop	 ecx
   add	 ecx,1
   cmp	 ecx,BPIPES
   jne	 .loop_segment


if 1

; rotate bezier curve pipe segment according to segment_rotary struct
   mov	 .cur_seg,0
   fninit
 .next_seg:
 ;  fldpi
 ;  fidiv [i180]
   fld	 [one_deg]
   fld	 st
   mov	 eax,.cur_seg
   shl	 eax,2
   lea	 eax,[eax*3]
   fimul dword[segments_rotary+eax]   ; x
   fsincos
   fstp  .seg_deg_sin_x
   fstp  .seg_deg_cos_x
   fld	 st
   fimul dword[segments_rotary+4+eax] ; y
   fsincos
   fstp  .seg_deg_sin_y
   fstp  .seg_deg_cos_y
   fimul dword[segments_rotary+8+eax] ; z
   fsincos
   fstp  .seg_deg_sin_z
   fstp  .seg_deg_cos_z


   mov	 esi,.cur_seg
   mov	 eax,BSTEPS*BSTEPS*12
   mul	 esi
   add	 eax,Bpoints_r
   mov	 .cur_seg_adres,eax
   mov	 esi,eax
   ; find center point of segment pipe
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movups   [cur_seg_max],xmm0
;   movups   [cur_seg_min],xmm1

   subps  xmm0,xmm1
   cvtsi2ss xmm2,[i2]
   shufps xmm2,xmm2,0
   divps  xmm0,xmm2
   addps  xmm0,xmm1  ; xmm0 - center of segment
   movups [cur_seg_center],xmm0

   ; substract pipe segment center
   mov	  esi,.cur_seg_adres
   mov	  ecx,BSTEPS*(BSTEPS)
 @@:
   movups  xmm2,[esi]
   subps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b

   pushad
   push   .seg_deg_sin_x
   push   .seg_deg_cos_x
   push   .seg_deg_sin_y
   push   .seg_deg_cos_y
   push   .seg_deg_sin_z
   push   .seg_deg_cos_z
   mov	  edi,Bmatrix
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   ; ..and rotate

   push   ebp
   mov	  ebx,Bmatrix
   mov	  ecx,BSTEPS*BSTEPS
   mov	  esi,.cur_seg_adres
   mov	  edi,esi
   call   rotary
   pop	  ebp

   movups xmm0,[cur_seg_center]
   mov	  esi,.cur_seg_adres
   mov	  ecx,BSTEPS*BSTEPS

   ; .. and add center point after rotary

 @@:
   movups  xmm2,[esi]
   addps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b
end if
   add	  .cur_seg,1
   cmp	  .cur_seg,BPIPES
   jne	  .next_seg






; do triangles list

   mov	esi,Btriangles
   mov	[Btriangles_count],0
   mov	.counter2,0	     ;segments counter
 .loop_seg_tri:
   mov	 eax,.counter2
   mov	 ecx,BSTEPS * BSTEPS
   mul	 ecx
   mov	 edx,BSTEPS - 2
   sub	 edx,.counter2
 .oop:
   mov	 ecx,BSTEPS - 1
 @@:
   mov	[esi],ax
   mov	bx,ax
   inc	ax
   mov	[esi+2],ax
   add	bx,BSTEPS
   mov	[esi+4],bx
   mov	[esi+6],bx
   inc	bx
   mov	[esi+8],bx
   mov	[esi+10],ax
   add	esi,12
   add	[Btriangles_count],2
   loop @b

   inc	eax
   dec	edx
   jnz	.oop

if 1
   ;last strip of triangles
   mov	 eax,BSTEPS * BSTEPS
   mul	 .counter2
   mov	 ecx,BSTEPS-2
   sub	 ecx,.counter2
 @@:
   mov	 [esi],ax
   mov	 bx,ax
   add	 bx,BSTEPS-1
   mov	 [esi+2],bx
   mov	 [esi+6],bx
   inc	 bx
   mov	 [esi+4],bx
   mov	 [esi+8],bx
   add	 bx,BSTEPS-1
;   add  ax,BSTEPS*2-1
   mov	 [esi+10],bx ;ax
   add	 esi,12
   add	 [Btriangles_count],2
   add	 eax,BSTEPS
   loop  @b
end if
   add	.counter2,1
   cmp	.counter2,BPIPES  ;[licznik_debug],1  ;BSEGMENTS+1
   jne	.loop_seg_tri



   mov	 esi,Btriangles 	   ; copy triangles list
   mov	 edi,[triangles_ptr]
   cld
   mov	 ecx,[Btriangles_count]
 @@:
   movsd
   movsw
   loop @b
   mov	dword[edi+4],-1




    mov ecx,[global_points_counter]
    mov eax,BSTEPS - 1	      ;000000000000000000000000000
    mul ecx
    mov [points_count_var],ax


   movzx eax,ax
   cdq
   mov	 ecx,BPIPES
   div	 ecx
   mov	 [rot_pipe_points_number],eax	   ; init this variable



   mov	 esi,Bpoints_r
   mov	 edi,[points_r_ptr]
   movzx ecx,[points_count_var]
   lea	 ecx,[ecx*3]
   rep	 movsd
   movsd



   mov	ebx, [Btriangles_count]
   mov	[triangles_count_var],bx
   jmp	.end_pipes
.skip_pipes:
;else if
    mov  [points_count_var],0
    mov  [triangles_count_var],0
.end_pipes:
;end if
;   cmp  BROTSOLIDS,0
;   je	 .skip_solids
if BROTSOLIDS>0

 ;****************************************************************


; do rotated solids


   mov	esi,Bx1_axis
   mov	edi,Bx2_axis
   mov	ebx,Bx_axis_v
   call make_vector_r
   mov	edi,Bx_axis_v
   call normalize_vector
   xor	eax,eax
   fninit
   fldpi
   fadd  st,st0
   mov	 .steps,BSTEPS
   fidiv .steps
   fstp  .one_deg




   mov	.rot_points_ptr,Bpoints_r      ; points describing rotated solid
   mov	.Bpoints_ptr,Bpoints+BSTEPS*BPIPES*12		; pointer to current non rotated curve segment
   mov	.segments_counter,0

 .loop_rot_solid2:

   xor	 eax,eax
 .loop_rot_solid1:

   push  eax
   mov	 ebx,Bx_axis_v
   mov	 edi,Bmatrix
   mov	 .counter,eax	     ; degrees counter
   fld	 .one_deg
   fimul .counter
   fsincos
   fstp  [Bsinus]
   fstp  [Bcosinus]
   lea	 esi,[Bsinus]
   call  make_arbitrary_mx

   mov	 ebx,Bmatrix
   mov	 ecx,BSTEPS   ;[maxcountervar]

   mov	 esi,.Bpoints_ptr
   mov	 edi,.rot_points_ptr
   pushad
   call  mul_matrix
   popad
   pop	 eax

   add	 .rot_points_ptr,BSTEPS*12
   add	 eax,1
   cmp	 eax,BROTARY_STEPS ;;+2  ;;	   <-----
   jne	 .loop_rot_solid1


 ;  rotate individual each segment of bezier solid

if 1

; rotate bezier curve segment according to segment_rotary struct
   fninit
   fld	 [one_deg]
   fld	 st
   mov	 eax,.segments_counter
   add	 eax,BPIPES
   shl	 eax,2
   lea	 eax,[eax*3]
   fimul dword[segments_rotary+eax]   ; x
   fsincos
   fstp  .seg_deg_sin_x
   fstp  .seg_deg_cos_x
   fld	 st
   fimul dword[segments_rotary+4+eax] ; y
   fsincos
   fstp  .seg_deg_sin_y
   fstp  .seg_deg_cos_y
   fimul dword[segments_rotary+8+eax] ; z
   fsincos
   fstp  .seg_deg_sin_z
   fstp  .seg_deg_cos_z

   mov	 esi,.rot_points_ptr
   sub	 esi,(BSTEPS*(BSTEPS))*12
   ; find center point of segment
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min

   subps  xmm0,xmm1
   cvtsi2ss xmm2,[i2]
   shufps xmm2,xmm2,0
   divps  xmm0,xmm2
   addps  xmm0,xmm1  ; xmm0 - center of segment
   movups [cur_seg_center],xmm0

   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  ecx,BSTEPS*(BSTEPS)
 @@:
   movups  xmm2,[esi]
   subps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b

   pushad
   push   .seg_deg_sin_x
   push   .seg_deg_cos_x
   push   .seg_deg_sin_y
   push   .seg_deg_cos_y
   push   .seg_deg_sin_z
   push   .seg_deg_cos_z
   lea	  edi,.matrix
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   ; ..and rotate

   push   ebp
   lea	  ebx,.matrix
   mov	  ecx,BSTEPS*BSTEPS
   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  edi,esi
   call   rotary
   pop	  ebp

   movups xmm0,[cur_seg_center]
   mov	  esi,.rot_points_ptr
   sub	  esi,(BSTEPS*(BSTEPS))*12
   mov	  ecx,BSTEPS*BSTEPS

   ; .. and add center point after rotary

 @@:
   movups  xmm2,[esi]
   addps   xmm2,xmm0
   movlps  [esi],xmm2
   movhlps xmm2,xmm2
   movss   [esi+8],xmm2
   add	   esi,12
   sub	   ecx,1
   jnz	   @b


end if

   add	 .Bpoints_ptr,BSTEPS * 12
   add	 .segments_counter,1
   cmp	 .segments_counter,BROTSOLIDS
   jnz	 .loop_rot_solid2

 ;  add translate vector from segment_add struct to every
 ;  Bezier curve segment
if 0
   xor	    eax,eax
   mov	    esi,Bpoints_r
 .next_seg_rot_solid:
   mov	    ecx,BSTEPS*BSTEPS
   mov	    ebx,eax
   shl	    ebx,2
   lea	    ebx,[ebx*3]
   movdqu   xmm1,[segments_add+ebx]
   cvtdq2ps xmm1,xmm1
 @@:
   movups   xmm0,[esi]
   addps    xmm0,xmm1
   movlps   [esi],xmm0
   movhlps  xmm0,xmm0
   movss    [esi+8],xmm0
   add	    esi,12
   sub	    ecx,1
   jnz	    @b
   add	    eax,1
   cmp	    eax,BROTSOLIDS
   jnz	    .next_seg_rot_solid
end if


   ; do triangles list

   mov	  esi,Btriangles
   mov	  [Btriangles_count],0	   ; do triangles list
   mov	  .seg_tri_counter,0
 .loop_seg_tri_rot_solid:
   mov	  edx,.seg_tri_counter
   mov	  eax,BSTEPS*BROTARY_STEPS
   mul	  edx
   add	  ax,[points_count_var]
   movzx  eax,ax
   mov	  edx,(BSTEPS-1)


   mov	  ebx,eax
  .oop2:
   mov	  ecx,BSTEPS-1
  @@:
   mov	  ax,bx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+6],ax
   mov	  [esi+4],ax
   add	  ax,BSTEPS-1
   mov	  [esi+2],ax
   mov	  [esi+8],ax
   inc	  ax
   mov	  [esi+10],ax
   add	  esi,12
   inc	  bx
   add	  [Btriangles_count],2
   loop   @b
   add	  bx,1

   dec	  dx
   cmp	  dx,0
   jnz	  .oop2


   mov	 eax, .seg_tri_counter
   add	 eax,1
   mov	 ecx,BSTEPS * BSTEPS
   mul	 ecx
   add	 ax,[points_count_var]	    ;;;
   movzx eax,ax 		    ;;;
   mov	 ecx,eax
   sub	 ecx,BSTEPS; - 1
   mov	 ebx,eax
   sub	 ebx,BSTEPS * BSTEPS
   mov	 .last_tri_counter,ebx
   add	 .last_tri_counter,BSTEPS - 1
 @@:
   mov	  eax,ebx
   mov	  [esi],ax
   inc	  ax
   mov	  [esi+2],ax
   mov	  [esi+4],cx
   mov	  [esi+6],cx
   inc	  cx
   mov	  [esi+8],ax
   mov	  [esi+10],cx
   add	  esi,12
   add	  [Btriangles_count],2
   inc	  ebx
   cmp	  ebx,.last_tri_counter
   jne	  @b


   add	 .seg_tri_counter,1
   cmp	 .seg_tri_counter,BROTSOLIDS
   jnz	 .loop_seg_tri_rot_solid

   mov	 [esi],dword -1



;  save in triangles, [points_r_ptr] lists

   mov	 esi,Btriangles
   movzx eax,[triangles_count_var]
   lea	 eax,[eax*3]
   mov	 edi,[triangles_ptr]
   lea	 edi,[edi+eax*2]
   cld
   mov	 ecx,[Btriangles_count]
 @@:
   movsd
   movsw
   loop @b

   mov	dword[edi+4],-1

;   movzx eax,[points_count_var]
;   cdq
;   mov   ecx,BROTSOLIDS
;   div   ecx
;   mov   [rot_pipe_points_number],eax	    ; init this variable


   mov	 esi,Bpoints_r
   mov	 edi,[points_r_ptr]
   movzx eax,[points_count_var]
   lea	 eax,[eax*3]
   shl	 eax,2
   add	 edi,eax
   mov	 ecx,BROTARY_STEPS*BSTEPS*BROTSOLIDS
   lea	 ecx,[ecx*3]
   rep	 movsd
   movsd

   mov	ebx, [Btriangles_count]
   add	[triangles_count_var],bx

   add [points_count_var],BROTARY_STEPS*BSTEPS*BROTSOLIDS ;ax

end if

;.skip_solids:


    pushad
    push   dword [points_r_ptr]
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords

  mov  esp,ebp
  popad
ret




