;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ave Cruce Salus Mea
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program: Win3ds12 - *.3ds / *.asc files viewer + demonstration of
;;	    several graphics effects + tiny based on Bezier curves,
;;	    3d objects editor.
;; author:  Maciej Guba aka macgub
;; web	 :  www.macgub.hekko.pl
;; email :  macgub3@wp.pl
;; This application don't uses any 3d graphic library
;; (OGL, GTK, ..etc). Written from scratch in pure assembler. Thanks
;; to all, who was helping me to do it.
;; Program needs SSE3, SSE4.1 or AVX extension.
;; Coding style is rather not perfect. Other words it's my own mess.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Keys / GUI Buttons description:
;;	    SPACE / dr. model button -	switching beetwen displaying
;;	       models: flat, smooth shading, spherical environment,
;;	       texture, bump, smooth + texture, two texture and bump
;;	       + texture mapping pararell, edges only (smooth shaded,
;;	       textured lines), flat with float single precision Z
;;	       coordinate, spot light with shadow light position
;;	       dependent;
;;	    TAB / ran. light - generate three unlinear directional
;;	       lights (Phongs illumination);
;;	    F1 / mot. blur - motion blur on/off;
;;	    F2 / cur object - cyclic switching between objects (from
;;	       file and predefined: heart (Sanctissimi Cordis Christi)
;;	       and tetrahedron), also turning on edit rotary Bezier
;;	       object option - ( Setting object parameters:
;;	       green line with	blue begin and end - rotary arbitrary
;;	       vector, green lines with red bars - derives, to change
;;	       derives	and arbitrary vector move cursor on red, or blue
;;	       bar, press left button on it and move mouse. Currently
;;	       edited object will be  show on the fly. Rotate independent
;;	       current segment of Bezier solid, marked with green frame,
;;	       by pressing and moving left mouse button on main view
;;	       window. Rotating independent segment around its center
;;	       point.); Also Bezier pipes editing option - (editing
;;	       pipes like in previous rotary object, but rotatry vector,
;;	       in this editing option its lenght determines Bezier pipes
;;	       radius, also independent pipe segment rotating around its
;;	       center point are implemented); Also rotated solids and
;;	       pipes pararell drawing possibility, editing options like
;;	       in previous causes. As I wrote, switching beetwen editing
;;	       options by pressing F2 / cur object GUI button;
;;	    F3/F4(+/-) keys / zoom in/out buttons - no comment;
;;	    F5 / tex. mapp. button - choose   bumps also texture mapping
;;	       planar or spherical (planar according to axis X, Y, Z);
;;	    F6 / bumps - switching between random bumps and texture
;;	       dependent;
;;	    F7 / texture - select  texture: red white stripes, xored face
;;	       and blank -  witch can by used in smoothing objects edges
;;	    F8 / save obj. - save 3d currently shown object to file
;;	       "object.asc" and "object.3ds";
;;	    F9 / cur.segm. - in Bezier rotated solid  option, also pipes
;;	       and rotated solids & pipes pararell - cyclic switching
;;	       between current segment, current segment marked by green
;;	       frame in two last editing options not works correct now;
;;	    F11 / run/stop button - main rotary on/off;
;;	    F12 / rotary - main rotary cyclic switching - around axis
;;	       X, Y, Z;
;;	    D  / do displ. - do displacement mapping texture dependent;
;;	    T  / do triang. - triangulize all objects faces - it's mean
;;	       divide each face to four smaller faces;
;;	    X - load texture (raw format 512X512 pixels 24bit 0xRRGGBB)
;;	    U  / rand. shd. button - random point (spot) light position
;;	       and obliquity of plane on wihch shadow falls.
;;	    ESC - exit;
;;	    Right mouse button and move - setting position of texture,
;;		  (works in all drawing models, but is visable only in
;;		  texture displaying models).
;;
;;	    After run program shows dialog to open file.
;;	    Choose file in 3ds or asc format and ...admire. ;)
;;
;;
;;
;;				      "No work is ever complete,
;;				       and this one is no exception."
;;							Pierre Bezier
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

format PE GUI 4.0
entry start

include '/include/win32a.inc'
BSEGMENTS = 2	    ; Bezier curve segments count
BPIPES = 1	    ; Bezier pipes count (only in solid and pipes
		    ; pararell editing cause).
BROTSOLIDS =  BSEGMENTS - BPIPES
BXRES	 equ 400 ;1600 ;1200 ;800      ;choose window size of bezier curve editor area
BYRES	 equ 400 ; 900 ; 675 ;450
BSIZE_X  equ BXRES
BSIZE_Y  equ BYRES
MXRES	 equ BXRES  ; menu window size
MYRES	 equ 250 ;BYRES
BROUND	 equ 8

BROTARY_STEPS = BSTEPS	 ; BROTARY_STEPS and BSTEPS  must have the same
		     ; value (both determines object quality|)
BSTEPS = 24


;XRES = 600 ;800 ;1600 ;1200 ;800      ;choose screen size
;YRES = 600  ;450 ;900 ; 675 ;450
;SIZE_X  = XRES
;SIZE_Y  = YRES
TEX_X = 512    ; texture size
TEX_Y = 512
TEXTURE_SIZE EQU (TEX_X * TEX_Y)-1
TEX_SHIFT = 9
TRIANGLES_COUNT equ 4
POINTS_COUNT equ 4
MAX_COUNTER equ 16    ; b_surface.inc  - determines triangles count
ROUND equ 8
NON  = 0  ; --\
MMX  = 1  ;    > this definitions are only for upside down
SSE  = 2  ; --/  compatible reasons
SSE2 = 3
SSE3 = 4
SSE4.1 = 5
AVX = 6
AVX2 = 7
Ext  =	SSE3
HEAP_MAX_SIZE = 1024 * 1024 * 20 ;1024	; = 1GB address space.


section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:

    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

     invoke  GetSystemMetrics,SM_CXSCREEN
     mov     [whole_xres],ax
     sub      eax,MXRES    ; place for menu and bezier curves area
     mov     ebx,eax
     mov     [xres_var],ax
     shr     eax,1
     mov     [xxadd],eax
     invoke  GetSystemMetrics,SM_CYSCREEN
     mov     [whole_yres],ax
     sub     eax,100
     mov     [yres_var],ax
     mov     ecx,eax
     shr     ecx,1
     mov     [yyadd],ecx

     lea     ecx,[ebx-3]
     cvtsi2ss xmm0,ecx
     movss   [max_clip_seg],xmm0
     lea     ecx,[eax-3]
     cvtsi2ss xmm0,ecx
     movss   [max_clip_seg+4],xmm0

     movzx   eax,[xres_var]
     movzx   ebx,[yres_var]

     mul     ebx
     shl     eax,2
     mov     ebx,eax
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:

    mov     [screen_ptr],eax
    mov     [line_buffer_var],eax
    mov     [lbuffer_ptr],eax



    invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [Zbuffer_ptr],eax
    shr     ebx,2
    invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov     [shd_buffer_ptr],eax

    mov   [bmi.biSize],sizeof.BITMAPINFOHEADER
    movzx eax,[xres_var]
    mov   [bmi.biWidth],eax  ;XRES
    movzx edx,[yres_var]

    neg   edx
 ;   sub   edx,30
    mov [bmi.biHeight],edx ;-YRES-30
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0


    mov [Bbmi.biSize],sizeof.BITMAPINFOHEADER
    mov [Bbmi.biWidth],BXRES
    mov [Bbmi.biHeight],-BYRES-30
    mov [Bbmi.biPlanes],1
    mov [Bbmi.biBitCount],32
    mov [Bbmi.biCompression],BI_RGB

    mov [Bbmi.biSizeImage],0
    mov [Bbmi.biXPelsPerMeter],0
    mov [Bbmi.biYPelsPerMeter],0
    mov [Bbmi.biClrUsed],0
    mov [Bbmi.biClrImportant],0

    mov [Mbmi.biSize],sizeof.BITMAPINFOHEADER
    mov [Mbmi.biWidth],MXRES
    mov [Mbmi.biHeight],-MYRES ;-30 ;-BYRES-30
    mov [Mbmi.biPlanes],1
    mov [Mbmi.biBitCount],32
    mov [Mbmi.biCompression],BI_RGB

    mov [Mbmi.biSizeImage],0
    mov [Mbmi.biXPelsPerMeter],0
    mov [Mbmi.biYPelsPerMeter],0
    mov [Mbmi.biClrUsed],0
    mov [Mbmi.biClrImportant],0



    mov   [rect.left],0
    mov   [rect.top],0
    movzx eax,[whole_xres]
    mov   [rect.right],eax
    movzx edx,[whole_yres]
    add   edx,30
;    neg edx
    mov   [rect.bottom],edx ;YRES+30

    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0

    invoke RegisterClass,wc



    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left]
    ; rasizable window
    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
				0, 0, eax, ecx, NULL, NULL, [wc.hInstance], NULL

;    invoke  CreateWindowEx, 0,_class, _title, WS_VISIBLE + WS_OVERLAPPEDWINDOW,\
;				 CW_USEDEFAULT, CW_USEDEFAULT, eax, ecx, NULL, NULL, [wc.hInstance], NULL
    ; non resizable window
 ;   invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
 ;	    xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW

    pushad
    movzx  eax,[yres_var]  ;YRES / 2
    shr    eax,1
    cvtsi2ss xmm0,eax
    movss  [scale],xmm0

    mov    edi,segments_rotary	 ; zero segment add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    cld
    rep    stosd


    mov    edi,segments_add	; zero segments add struct
    xor    eax,eax
    mov    ecx,BSEGMENTS*3
    rep    stosd


    mov    edi,menu_screen		 ; zero menu screen
    mov    ecx,MXRES * MYRES
    rep    stosd

;    mov    eax,0x00ffffff
;    mov    ecx,MENU_XRES * MENU_YRES/2
;    rep    stosd


    call   normalize_plane_equation

    call   Binit_derives

    call   open_file
    cmp    [file_ext_flag],0
    jne    @f
    call   read_tp_variables
    call   alloc_mem_for_tp
    call   read_from_file     ; 3ds
    jmp    .norm
  @@:
;    cmp    [file_ext_flag],1
    call   read_asc_tp_variables
    call   alloc_mem_for_tp
    call   read_asc		; asc
  .norm:

    call   prepare_object
    call   normalize_all_light_vectors
  ;  call   calc_p_light_coords
  ;  mov    ebx,shadow_matrix
  ;  mov    esi,point_light_coords
  ;  call   calc_shadow        ; calculate 4x4 shadow matrix

    call   init_envmap2
    call   do_color_buffer
    mov    edi,bump_map
    call   calc_bumpmap
    call   generate_texture2
    call   draw_menu
    popad
msg_loop:
    stdcall g_draw
    movzx eax,[ccounter_inc]

    cmp   [rotary_flag],0
    jne   @f
    add   dword[main_rotary],eax
    and   dword[main_rotary],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],1
    jne   @f
    add   dword[main_rotary+4],eax
    and   dword[main_rotary+4],0xff
    jmp   .end_rot_inc
  @@:
    cmp   [rotary_flag],2
    jne   @f
    add   dword[main_rotary+8],eax
    and   dword[main_rotary+8],0xff
  @@:

  .end_rot_inc:

; draw image

    movzx  eax,[xres_var]
    movzx  ebx,[yres_var]
    lea    edx,[ebx+30]

    invoke StretchDIBits,[hdc],0,30,eax,edx,0,0,eax,ebx,[screen_ptr],bmi,0,SRCCOPY


;    call draw_menu
    movzx    eax,[whole_xres]
    mov      ecx,eax
    sub      eax,MXRES

    invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY


    cmp  [hrt_flag],3		 ; hrt_flag indicates what object is current
    jl	 @f

    call   Bdraw_all
    movzx  eax,[whole_xres]
    movzx  ebx,[whole_yres]
    sub    ebx,(100+BYRES) ; 30
    sub    eax,BXRES


     invoke StretchDIBits,[hdc],eax,ebx,BXRES,BYRES,0,0,BXRES,BYRES,Bbuffer,Bbmi,0,SRCCOPY

  @@:
; .no_editor:
    movzx  eax,[draw_flag]
    mov    ebx,36  ; 36 - text chain lenght
    mul    ebx
    add    eax,sh_model
    invoke TextOut,[hdc],10,10,eax,36


    invoke Sleep,2

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or eax,eax
    je end_loop

    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:

    movzx    ebx,[xres_var]
    movzx    eax,[yres_var]
    mul      ebx
    shl      eax,2
    invoke  VirtualFree,[screen_ptr], eax, MEM_DECOMMIT
    call    free_mem_for_tp

    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je .wmkeydown
   @@:
     cmp   [wmsg],WM_LBUTTONDOWN
     jne   .next_mess345
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     cmp   ax,-MXRES
     jl    .bez
     ror   eax,16
     cmp   ax,MYRES  ; menu work
     jg    .bez
     ror   eax,16
     mov   esi,menu_data
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     add   ax,MXRES
  @@:
     push  eax
     mov   ecx,[esi+2]
     mov   edx,[esi+6]
     call  xy_in_rect
     pop   eax
     or    ebx,ebx
     jnz   @f
     add   esi,33		; size of one position in menu
     cmp   [esi],word -1	; end mark
     jnz   @b
     jmp  .bez
  @@:
     mov   ax,[esi+2]
     add   ax,2
     shl   eax,16
     mov   ax,[esi+6]
     sub   ax,2
     mov   bx,[esi+4]
     add   bx,2
     shl   ebx,16
     mov   bx,[esi+8]
     sub   bx,2
     mov   [screen_width_var],MXRES
     mov   [lbuffer_ptr],menu_screen
     mov   [line_color],0x0000ff00
     pushad
     call  write_frame
     popad
     mov   word[esi],1	    ;mark button chosen

     movzx    eax,[whole_xres]
     sub      eax,MXRES

     invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY

   .bez:
     cmp   [hrt_flag],3
     jl    .next_mess345
     mov   eax,[lparam]
     sub   ax,[whole_xres]  ;XRES-BXRES
     add   ax,BXRES
     ror   eax,16
     sub   ax,[whole_yres]  ;YRES+30-BYRES
     add   ax,BYRES+100
     ror   eax,16
     cmp   ax,BXRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,BYRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16


     movzx ebx,ax
     shr   eax,16
     mov   edx,BXRES
     mul   edx
     add   eax,ebx
     shl   eax,2
     add   eax,Bbuffer
     mov   ebx,[eax]
     and   ebx,0xff000000
     cmp   ebx,0xff000000
     je    .next_mess345
     shr   ebx,24
     mov   [Bcrucial_point],ebx
     mov   [Bmove_flag],1
     jmp   .next_mess345
  @@:
     cmp   [current_seg],255
     je    @f
if 0
     mov   eax,[lparam]
     ror   eax,16
     sub   ax,30

     cmp   ax,[yres_var] ;YRES
     jg    @f
     cmp   ax,0
     jl    @f
     ror   eax,16
     cmp   ax,[xres_var]  ;XRES
     jg    @f
     cmp   ax,0
     jl    @f
end if
     mov   [seg_rot_flag_button_down],1
  @@:
   .next_mess345:
     cmp   [wmsg],WM_MOUSEMOVE
      jne   .next_msg

     cmp   [seg_rot_flag_button_down],1
     jne   .Bezier_mov
     cmp   [hrt_flag],3
     jge   @f
     jmp   .Bezier_mov

   @@:
     mov   eax,[lparam]    ; rotate single segment of bezier
					    ; rotated solid
     ror   eax,16
     sub   ax,100
     movzx ebx,ax
     shr   eax,16
     movzx ecx,[current_seg]
     shl   ecx,2
     lea   ecx,[ecx*3]
     and   eax,0xff
     and   ebx,0xff
     mov   [segments_rotary+ecx],eax
     mov   [segments_rotary+ecx+4],ebx
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],3
     jne   @f
     call  save_object
     jmp   .Bezier_mov
   @@:
     cmp   [hrt_flag],4
     jne   @f
     call  save_pipe
     jmp   .Bezier_mov
   @@:
     call  save_pipe_rot_solid
   .Bezier_mov:
     cmp   [Bmove_flag],1
     jne   .next_msg
     mov   ecx,[lparam]
     mov   ax,[whole_xres]
     sub   ax,BXRES
     cmp   cx,ax  ;XRES-BXRES
     jl    .next_msg
     ror   ecx,16
     mov   bx,[whole_yres]
     sub   bx,BYRES
     sub   bx,100
     cmp   cx,bx  ;YRES+30-BYRES
     jl    .next_msg
     sub   cx,bx   ;YRES+30-BYRES
     ror   ecx,16
     sub   cx,ax   ;XRES-BXRES

     mov   ebx,[Bcrucial_point]
     cmp   ebx,253		   ; check if axis
     jae   @f
     shl   ebx,2
     mov   [ebx+Biderives],ecx
     jmp   .draw
    @@:
     sub   ebx,253
     shl   ebx,2
     mov   [ebx+Bix1_axis],ecx
   .draw:
     pushad
     call  Bdraw_all
     popad
     cmp   [hrt_flag],4
     jne   @f
     call  save_pipe	    ; save changes - on the fly write to points / triangles lists
     jmp   .next_msg
   @@:
     cmp   [hrt_flag],5
     jne   @f

     call  save_pipe_rot_solid
     jmp  .next_msg
   @@:
     call  save_object	 ; if hrt_flag = 3 save solid rotared curve


  .next_msg:
     cmp   [wmsg],WM_LBUTTONUP
     jne   .rbutd
     mov   [seg_rot_flag_button_down],0
     mov   [Bmove_flag],0

     ; GUI buttons work
     mov   eax,[lparam]     ; check if sth in menu marked
     sub   ax,[whole_xres]
     cmp   ax,-MXRES
     jl    .dr_mn
     ror   eax,16
     cmp   ax,MYRES
     jg    .dr_mn
     ror   eax,16
     mov   esi,menu_data
     mov   eax,[lparam]
     sub   ax,[whole_xres]
     add   ax,MXRES
  @@:
     push  eax
     mov   ecx,[esi+2]
     mov   edx,[esi+6]
     call  xy_in_rect
     pop   eax
     or    ebx,ebx
     jnz   @f
     add   esi,33		; size of one position in menu
     cmp   [esi],word -1
     jnz   @b
     jmp  .dr_mn
  @@:
     cmp   word[esi],1
     jne   .dr_mn
     ; this button was pressed (pointed in esi)
			    ; update flags
     mov   word[esi],0	    ; mark
     mov   al,byte[esi+22]
     inc   al
     cmp   al,[esi+21]
     jne   @f
     xor   al,al
   @@:
     mov   [esi+22],al
     mov   ax,[esi+27]
     mov   [menu_button_number],ax
   .dr_mn:

     mov    edi,menu_screen
     cld
     mov    ecx,MXRES*MYRES
     xor    eax,eax
     rep    stosd
     call   draw_menu
if 0
     mov   ax,[esi+2]
     add   ax,2
     shl   eax,16
     mov   ax,[esi+6]
     add   ax,2
     mov   bx,[esi+4]
     sub   bx,2
     shl   ebx,16
     mov   bx,[esi+8]
     sub   bx,2
     mov   [screen_width_var],MXRES
     mov   [lbuffer_ptr],menu_screen
     mov   [line_color],0x00000000
     pushad
     call  write_frame
     popad
     mov   word[esi],0	    ;mark
end if

  .rbutd:
    cmp   [wmsg],WM_RBUTTONDOWN
    jne   @f
    mov   [tex_button_pres],1
    mov   eax,[lparam]
    mov   [tex_mov_begin_x],eax

  @@:
    cmp   [wmsg],WM_RBUTTONUP
    jne   @f
    mov   [tex_button_pres],0
    jmp   .next_1
  @@:

    cmp    [wmsg],WM_MOUSEMOVE
    jne    @f
    cmp    [tex_button_pres],1
    jne    @f

    movd   xmm0,[lparam]
    movd   xmm1,[tex_mov_begin_x]

    psubw  xmm1,xmm0
    movd   eax,xmm1
    movd   [tex_mov_begin_x],xmm0
    mov    ebx,eax
    sar    ebx,16
    cwde
    call   move_texture
   @@:
 .next_1:

    cmp    [wmsg],WM_DESTROY
    je	   .wmdestroy

  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp    .finish

  .wmkeydown:
    cmp   [wparam],VK_UP
    jne   @f
    xor   eax,eax
    jmp   .finish
  @@:

    mov   eax,[wparam]
    call  update_flags_after_keypress

    cmp   [wparam],0x58 ;  'x'
    jne   @f
    call   open_texture
  @@:

    cmp   [wparam],VK_ESCAPE
    jne   .finish

  .wmdestroy:
    invoke PostQuitMessage,0
    xor    eax,eax

  .finish:    ; GUI buttons
    cmp   [menu_button_number],3  ; zoom in
    jne   @f
    fninit
    fld   [scale]
    fmul  [scale_plus]
    fstp  [scale]
    jmp   .end
  @@:
    cmp   [menu_button_number],4  ; zoom out
    jne   @f
    fninit
    fld   [scale]
    fmul  [scale_minus]
    fstp  [scale]
    jmp   .end
  @@:
    cmp   [menu_button_number],5  ; tex map
    jne   @f	     ; bump, texture - spherical or planar mapping
    call  calc_bumpmap_coords
    jmp   .end
  @@:
    cmp   [menu_button_number],6  ; random directional lights
    jne   @f
    call  make_random_lights
    call  normalize_all_light_vectors
 ;   call  calc_p_light_coords
    call  do_color_buffer
    call  init_envmap2
    jmp   .end
   @@:
    cmp   [menu_button_number],7  ; displaying models
    jne   @f
    movzx  eax,[xres_var]
    invoke StretchDIBits,[hdc],0,0,eax,30,0,0,1,1,fakebitmap,bmi,0,SRCCOPY
    jmp   .end
  @@:
    cmp   [menu_button_number],8  ; bumps random/texture dependent
    jne   @f
    call  calc_bumpmap
  @@:
    cmp   [menu_button_number],9  ; bumps random/texture dependent
    jne   .next_no
    cmp   [tex_flag],0
    jne   @f
    call  generate_texture2    ; draw stripes
    jmp   .tex_end
  @@:
    cmp   [tex_flag],1
    jne   @f
    call  generate_texture3	; draw xor
    jmp   .tex_end
  @@:
    call  generate_texture1	; white area
  .tex_end:
    call  calc_bumpmap
  .next_no:
    cmp   [menu_button_number],10  ; save 3d object
    jne   @f
    call  write_asc
    call  save3ds
    jmp   .end
  @@:
    cmp   [menu_button_number],12  ; active segment chosen
    jne   .seg_ch_end
    cmp   [hrt_flag],3
    jl	  .seg_ch_end
    inc   [current_seg]
    cmp   [current_seg],BSEGMENTS
    jne   @f
    mov   [current_seg],0
  @@:
    pushad
    call  Bdraw_all
    popad
    cmp  [hrt_flag],3
    jne  @f
    call save_object
    jmp   .end
  @@:
    cmp   [hrt_flag],4
    jne   @f
    call  save_pipe
    jmp   .end
  @@:
    call  save_pipe_rot_solid
    jmp  .end
  .seg_ch_end:
;    cmp   [menu_button_number],13  ; load texture
;    jne   @f
;    call  open_texture
;    jmp   .end
;   @@:

    cmp   [menu_button_number],13  ; do displacement
    jne   @f
    pushad
    call  apply_displacement_from_tex
    popad
    call   prepare_object
    jmp   .end
   @@:


    cmp   [menu_button_number],14  ; do displacement
    jne   .triang_end
    cmp   [points_count_var],16000  ; 65536/4 - max triangles,
    jg	  .triang_end		   ;	     vertexes count
    cmp   [triangles_count_var],16000
    jg	  .triang_end
    pushad
    call  triangulize_all_faces
    popad
    mov   [tp_mem_alloc],1
    call  alloc_mem_for_tp
    mov   [tp_mem_alloc],0
    call   prepare_object
    jmp   .end
  .triang_end:


    cmp   [menu_button_number],15  ; do displacement
    jne   .active_obj_end
    cmp   [hrt_flag],1
    jne   @f
    call  read_hrt
    call   prepare_object
    jmp    .end

  @@:
    cmp   [hrt_flag],2
    jne    @f
    call   load_tetrahedron
    call   prepare_object
    jmp    .end

  @@:
     cmp   [hrt_flag],3
     jne   @f
     mov   [triangles_count_var],BROTARY_STEPS*BSTEPS*BSEGMENTS*2
     mov   [points_count_var],BROTARY_STEPS*BSTEPS*BSEGMENTS*5/4
     call  alloc_mem_for_tp
     pushad
     call  Bdraw_all
     popad
     call  save_object	      ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end

 @@:
     cmp   [hrt_flag],4
     jne   @f
     pushad
     call  Bdraw_all
     popad
     call  save_pipe	    ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end

  @@:
     cmp   [hrt_flag],5
     jne   @f
     pushad
     call  Bdraw_all
     popad
     call  save_pipe_rot_solid	     ; save changes - on the fly write to points / triangles lists
     call  prepare_object
     jmp   .end
  @@:

    cmp    [file_ext_flag],0
    jne    @f
    pushad
    call   read_tp_variables  ; 3ds
    call   alloc_mem_for_tp
    call   read_from_file
    popad
    call   prepare_object
    jmp    .end
   @@:
    call   read_asc_tp_variables  ; asc
    call   alloc_mem_for_tp
    call   read_asc
    call   prepare_object
    jmp   .end
  .active_obj_end:

    cmp   [menu_button_number],16  ; random point light position
    jne   @f			   ; and plane equation
    call   random_point_light_position
    call   normalize_plane_equation
    jmp   .end
  @@:


  .end:
    mov   [menu_button_number],0
    ret
endp

prepare_object:
    pushad
    push   dword [points_r_ptr]
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    call   init_triangles_normals2
    call   init_point_normals
    popad
    call   calc_bumpmap_coords
ret

update_flags_after_keypress:
  ;   in ax - wparam
     pushad
     mov   esi,menu_data
   @@:
     cmp   word[esi+29],ax
     je    .updat
     cmp   word[esi+31],ax
     je    .updat
     add   esi,33
     cmp   word[esi],-1
     jnz   @b
     jmp   .end
  .updat:
     mov   al,byte[esi+22]
     inc   al
     cmp   al,[esi+21]
     jne   @f
     xor   al,al
   @@:
     mov   [esi+22],al
     mov   ax,[esi+27]
     mov   [menu_button_number],ax

     mov    edi,menu_screen
     cld
     mov    ecx,MXRES*MYRES
     xor    eax,eax
     rep    stosd
     call   draw_menu
   .end:
     popad
ret


open_texture:

   mov	   [ofntex.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofntex
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fnametex,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfiletex],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfiletex],0
   cmp	   eax,-1
   je	   .failed
   cmp	   eax,TEX_X*TEX_Y*3
   jnae    .failed
   mov	   [FileSize],eax
   cmp	   [pmemtex],0
   jne	   .heap_realloc
   invoke  GetProcessHeap
   mov	   [hheap],eax
   invoke  HeapAlloc,[hheap],0,[FileSize]
   jmp	   .read_file

 .heap_realloc:
   invoke  HeapReAlloc,[hheap],0,[pmem],[FileSize]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; read raw file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 .read_file:	  ; read texture
   mov	   [pmemtex],eax
   mov	   ebx,eax
   invoke  ReadFile,[hfiletex],[pmemtex],[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfiletex]
   mov	   [hfiletex],0

   mov	   esi,[pmemtex]  ;ebx
   mov	   edi,texmap
   cld

   mov	    ecx,TEX_X*TEX_Y  ;eax

   xor	    eax,eax
 @@:
   movsw
   movsb
   stosb
   loop  @b

   mov	   eax,[BytesRead]
  .init_ptr:
   mov	   [File_tex_ptr],ebx
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret


 .read_error:
   invoke  HeapFree,[hheap],0,[pmemtex]
   mov	   [pmemtex],0

 .failed:
   cmp	   [hfiletex],0
   je	   @f
   invoke  CloseHandle,[hfiletex]
  @@:
   invoke  MessageBox,[hwnd],_notraw,0,MB_OK
   .cancel:
ret


open_file:

   mov	   [ofn.Flags],OFN_FILEMUSTEXIST+OFN_PATHMUSTEXIST+OFN_EXPLORER
   invoke  GetOpenFileName,ofn
   or	   eax,eax
   jz	   .cancel

   invoke  CreateFile,fname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
   mov	   [hfile],eax
   cmp	   eax,-1
   je	   .failed
   invoke  GetFileSize,[hfile],0
   cmp	   eax,-1
   je	   .failed
   mov	   [FileSize],eax
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   mov	   [File_ptr],eax
   invoke  ReadFile,[hfile],eax,[FileSize],BytesRead,0
   or	   eax,eax
   jz	   .read_error
   invoke  CloseHandle,[hfile]
   mov	   [hfile],0

   mov	   eax,[BytesRead]
   mov	   ebx,[File_ptr]
   mov	   cx,WORD [ebx]
   cmp	   cx,'MM'
   je	  @f
   mov	   [file_ext_flag],1  ; asc
   jmp	   .init_ptr
 @@:
   mov	   [file_ext_flag],0
 .init_ptr:
   invoke  InvalidateRect,[hwnd],0,1
   xor	   eax,eax
   ret
 .read_error:
 .failed:
   cmp	   [hfile],0
   je	   @f
   invoke  CloseHandle,[hfile]
  @@:
   invoke  MessageBox,[hwnd],_not3ds,0,MB_OK
   .cancel:
   invoke  ReleaseDC,[hwnd],[hdc]
   invoke  DestroyWindow,[hwnd]
   invoke  ExitProcess,[msg.wParam]
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer; main program proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw ;uses ebx esi edi
local .temp dw ?, .rot_flag dw ?
;local .first_p_index dd ?, .second_p_index dd ?, .third_p_index dd ?
;local .zz1 dw ?, .zz2 dw ?, .zz3 dw ? ;-> don't change order
local .zz1f dd ?, .zz2f dd ?,.zz3f dd ?
local .xx1f dd ?,.xx2f dd ?,.xx3f dd ?
local .yy1f dd ?,.yy2f dd ?,.yy3f dd ?
local .xx1 dw ?, .xx2 dw ?, .xx3 dw ?
local .yy1 dw ?, .yy2 dw ?, .yy3 dw ?
local .xy1 dd ?, .xy2 dd ?, .xy3 dd ?
local .dpr dd ?, .dpr_p dd ?
local .x_temp_var dd ?, .y_temp_var dd ?
local .counter dd ?
local .sinx dd ?, .cosx dd ?
local .siny dd ?, .cosy dd ?
local .sinz dd ?, .cosz dd ?
local .matrix rb 36
local .shadow_matrix rb 64
local .dot_pr_light   dd ?
;local .p_light_vec rd 4
local .shd_vertices rd	12
;local .shd_counter dd ?
; local .temp_vect dqword ?
    pushad
    cmp   [blur_flag],1
    jne   @f
    xor   eax,eax	   ; clear draw buffer
    mov   edi,[screen_ptr]
    cld
;    mov  ecx,XRES * YRES
    movzx ebx,[xres_var]
;    sub   ebx,BSIZE_X
    movzx ecx,[yres_var]
    imul  ecx,ebx
    rep   stosd
    jmp   .no_blur
  @@:
    mov   ecx,1
    call  blur_screen
  .no_blur:
    cmp   [draw_flag],10
    je	  @f
    mov   eax,5000*65536    ; make background to Zbuffer
    jmp   .m_back
  @@:
    mov   eax,6000.1
  .m_back:
    mov   edi,[Zbuffer_ptr]
    movzx ecx,[xres_var]
    movzx ebx,[yres_var]
    imul  ecx,ebx
    rep   stosd


  .rotate:
if 1

   fninit
   fld	 [one_deg]
   fld	 st
   fimul dword[main_rotary+8]	; z
   fsincos
   fstp  [.sinx]
   fstp  [.cosx]
   fld	 st
   fimul dword[main_rotary] ; x
   fsincos
   fstp  [.siny]
   fstp  [.cosy]
   fimul dword[main_rotary+4] ; y
   fsincos
   fstp  [.sinz]
   fstp  [.cosz]

   pushad
   push   [.sinx]
   push   [.cosx]
   push   [.siny]
   push   [.cosy]
   push   [.sinz]
   push   [.cosz]
   lea	  edi,[.matrix]
   call   make_rotation_matrix
   ; edi -  desired matrix
   popad

   push   ebp
   mov	  esi,[points_normals_ptr]	     ; rotate normals
   mov	  edi,[points_normals_rotated_ptr]
   movzx  ecx,[points_count_var]
   lea	  ebx,[.matrix]
   call   rotary
   pop ebp


   push   ebp


   lea	esi,[.matrix] ;esi - pointer to 3x3 matrix
   mov	ebx,scale     ;ebx - ptr to scale
   call add_scale_to_matrix


   lea	  ebx,[.matrix]
   movzx  ecx,[points_count_var]
   mov	  esi,[points_r_ptr]
   mov	  edi,[points_rotated_ptr]
   call   rotary
   pop	  ebp

end if
    cmp    [draw_flag],14
    jne    .no_shadow
  ;  int3
    ;  draw background image
	pushad
	push	word 5500
	push	word 5500
	push	word 5500
	push	dword 1 * 65536 + 511
	push	dword 511 * 65536 + 1
	push	dword 1 * 65536 + 1

	mov    eax, 1 * 65536 + 1
	mov    bx, [xres_var]
	shl    ebx,16
	mov    bx, 1
	mov    ecx, 1 * 65536
	mov    cx,[yres_var]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z


	push	word 5500
	push	word 5500
	push	word 5500
	push	dword 1 * 65536 + 511
	push	dword 511 * 65536 + 511
	push	dword 511*65536 + 1

	mov    ax,[xres_var]
	shl    eax,16
	mov    ax,1
	mov    bx, [xres_var]
	shl    ebx,16
	mov    bx, [yres_var]
	mov    ecx, 1 * 65536
	mov    cx,[yres_var]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z
	popad


	;make background in shd buff
	movzx eax,[xres_var]
	movzx ecx,[yres_var]
	mul   ecx
	mov   ecx,eax
	shr   ecx,2
	xor   eax,eax
	mov   edi,[shd_buffer_ptr]
	cld
	rep   stosd


	movzx ecx,[triangles_count_var]
	mov   esi,[triangles_ptr]
   .again_shd_tri:
 ;  int3
	push   esi
	push   ecx
	mov    [shd_counter],0
      .next_shd_vert:
	mov	eax,[shd_counter]
	movzx	edx,word[eax*2+esi]
	imul	edx,[i12]
	add	edx,[points_rotated_ptr]  ; [edx] - cur vertex
	movups	xmm0,[edx]
	andps	xmm0,[zero_hgst_dd]
	subps	xmm0,[point_light_coords]
	movaps	xmm1,xmm0
	mulps	xmm1,xmm1
	haddps	xmm1,xmm1
	haddps	xmm1,xmm1
    ;	 shufps  xmm1,xmm1,0
	andps	xmm1,[zero_hgst_dd]
	rsqrtps xmm1,xmm1
	mulps	xmm0,xmm1    ; xmm0 - normalized light vector
	andps	xmm0,[zero_hgst_dd]
	movups	[p_light_vec],xmm0  ;+eax

	pushad
	lea    ebx,[.shadow_matrix]
	lea    esi,[p_light_vec]   ; +eax
	call   calc_shadow	  ; calculate 4x4 shadow matrix
	popad
	pushad
    ;	 push	ebp
	mov    esi,edx
	mov    ecx,1
	mov    eax,[shd_counter]
	shl    eax,4
	lea    ebx,[.shadow_matrix]
	lea    edi,[.shd_vertices]
	add    edi,eax
	call   mul_matrix4x4
     ;	 pop	ebp
	popad
	add    [shd_counter],1
	cmp    [shd_counter],3
	jnz    .next_shd_vert



      ;  int3
	lea	 ebx,[.shd_vertices]
	movups	 xmm0,[ebx]
	movdqu	 xmm3,[xxadd]
	movups	 xmm1,[ebx+16]
	movups	 xmm2,[ebx+32]

	cvtps2dq xmm0,xmm0
	cvtps2dq xmm1,xmm1
	cvtps2dq xmm2,xmm2
	paddd	 xmm0,xmm3
	paddd	 xmm1,xmm3
	paddd	 xmm2,xmm3

	packssdw xmm0,xmm0
	packssdw xmm1,xmm1
	packssdw xmm2,xmm2
	movd	 eax,xmm0
	movd	 ebx,xmm1
	movd	 ecx,xmm2
	ror	 eax,16
	ror	 ebx,16
	ror	 ecx,16
	mov	 edx,0xffafafaf
	mov	 edi,[screen_ptr]
	mov	 esi,[shd_buffer_ptr]
    ; int3
	pushad
    ;	 push	 ebp
	call	triangle_shd
   if 0
	pushad
	push	word 500
	push	word 500
	push	word 500
	push	dword 1 * 65536 + 1
	push	dword 1 * 65536 + 1
	push	dword 1 * 65536 + 1

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z
	popad
    end if
    if 0
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	push  word 500
	push  dword 10 shl 16 + 10
	push  word 10
	mov   esi,[Zbuffer_ptr]
	mov   edi,[screen_ptr]
	call  gouraud_triangle_z
     end if

      ;  pop	 ebp
	popad
	pop	ecx
	pop	esi
	add	esi,6
	dec	ecx
	jnz    .again_shd_tri


.no_shadow:
    ; set in center of window
  ;   movss    xmm2,[scale]
 ;   shufps   xmm2,xmm2,0
    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    movzx    ecx,[points_count_var]
    mov      ebx,[points_rotated_ptr]
 @@:
    movups   xmm1,[ebx]
 ;   mulps    xmm1,xmm2
    addps    xmm1,xmm3
    movlps   [ebx],xmm1
    movhlps  xmm1,xmm1
    movss    [ebx+8],xmm1
    add      ebx,12
    sub      ecx,1
    jnz      @b



 .draw:
    mov   esi,[triangles_ptr]		 ; draw triangles
    movzx ecx,[triangles_count_var]
  .draw_triangle:
    push  ecx
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [first_p_index],edx
    add   edx,[points_rotated_ptr]
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fst   [.xx1f]
    fistp [.xx1]
    movzx eax,[.xx1]
    shl   eax,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fst   [.yy1f]
    fistp [.yy1]
    mov   ax,[.yy1]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  word[zz1]
    fstp  [.zz1f]
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [second_p_index],edx
    add   edx,[points_rotated_ptr]
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fst   [.xx2f]
    fistp [.xx2]
    movzx ebx,[.xx2]
    shl   ebx,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fst   [.yy2f]
    fistp [.yy2]
    mov   bx,[.yy2]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  [zz2]
    fstp  [.zz2f]

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   [third_p_index],edx
    add   edx,[points_rotated_ptr]
    fld   dword[edx]
;    fmul  [scale]
;    fiadd word[xxadd]
    fst   [.xx3f]
    fistp [.xx3]
    movzx ecx,[.xx3]
    shl   ecx,16
    fld   dword[edx+4]
;    fmul  [scale]
;    fiadd [yyadd]
    fst   [.yy3f]
    fistp [.yy3]
    mov   cx,[.yy3]
    fld   dword[edx+8]
;    fmul  [scale]
;    fiadd [zzadd]
    fist  [zz3]
    fstp  [.zz3f]

    mov     [.xy1],eax
    mov     [.xy2],ebx
    mov     [.xy3],ecx

    push  esi
    pushad

    cmp   [draw_flag],1
    je	  .flat_draw
    cmp   [draw_flag],3
    je	  .env_mapping
;    je    .flat_draw_float
;    cmp   [draw_flag],8
;    je    .flat_draw_float
    cmp   [draw_flag],4
    je	  .bump_mapping
    cmp   [draw_flag],5
    je	  .tex_mapping
    cmp   [draw_flag],8
    je	  .bump_tex_mapping
    cmp   [draw_flag],7
    je	  .two_tex
    cmp   [draw_flag],6
    je	  .grd_tex
    cmp   [draw_flag],9
    je	  .grd_line
    cmp   [draw_flag],10
    je	  .flat_draw_float
    cmp   [draw_flag],0
    je	  .draw_dots
    cmp   [draw_flag],11
    je	  .tex_line
    cmp   [draw_flag],12
    je	  .tex_line
    cmp   [draw_flag],13
    je	  .flat_line
    cmp   [draw_flag],14
    je	  .point_light

     .grd_draw: 	       ;****Gouraud shading****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_draw:
	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_draw

if 0
   ; -----------version with only one light supported------
    mov   [.counter],4	    ; ++++ gouraud shading  ++++++++
  .calc_col_LVD:    ; calculate color Light Vector Depend
    mov   edx,[.counter]
    push  [zz1+edx]
; calc color of triangle light vector dependent
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index+2*edx]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx


    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

;    shufps    xmm3,xmm3,11000110b

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxuw    xmm3,[minimum0]
;    pminuw    xmm3,[maximum255]

    movd      edx,xmm3
  ;  ror       edx,16
    push      edx
    psrldq    xmm3,4
    movd      edx,xmm3
    push      dx

    sub   [.counter],2
    cmp   [.counter],0
    jge   .calc_col_LVD


end if

    mov     eax,[.xy1]
    mov     ebx,[.xy2]
    mov     ecx,[.xy3]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z
    jmp   .end_draw

  .point_light:

    movups   xmm5,[point_light_coords]
    xor      eax,eax
  .next_vertex:
    movaps   xmm1,xmm5
    mov      ebx,[first_p_index+2*eax]

    mov      edx,ebx
    add      ebx,[points_rotated_ptr]
    movups   xmm2,[ebx]
    andps    xmm2,[zero_hgst_dd]
    subps    xmm1,xmm2
    sub      esp,16
    movups   [esp],xmm1
    mov      edi,esp
    call     normalize_vector  ; uses xmm6,xmm7
    movups   xmm1,[edi]
    add      esp,16
    add      edx,[points_normals_rotated_ptr]
    movups   xmm3,[edx]
    andps    xmm3,[zero_hgst_dd]
    mulps    xmm3,xmm1
    haddps   xmm3,xmm3	   ; sse3 required
    haddps   xmm3,xmm3	   ; xmm3 - dot product
    xorps    xmm4,xmm4
    maxps    xmm3,xmm4
    shufps   xmm3,xmm3,11000000b
    movaps   xmm4,xmm3
    mov      ecx,5
  @@:
    mulps    xmm4,xmm4
    loop     @b

;    imul     eax,[i38]     ; 38 - one light parameter size
    movq      xmm0,[p_light_max]    ;+eax
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    mulps     xmm4,xmm2     ; xmm4 reflection(emmisive?) component of light

    movq      xmm0,[p_light_o] ;+ eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm4,xmm2

    movq      xmm0,[p_light_min] ; + eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0

    mulps     xmm2,xmm3
    addps     xmm4,xmm2
    minps     xmm4,[mask_255f]

    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4

    movd      edx,xmm4
    push      word[zz1+eax]
    push      edx
    psrldq    xmm4,4
    movd      edx,xmm4
    push      dx

    add       eax,2
    cmp       eax,6
    jnz       .next_vertex

    mov     eax,[.xy3]
    mov     ebx,[.xy2]
    mov     ecx,[.xy1]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z


    jmp   .end_draw





  .draw_dots:
	mov	edi,[screen_ptr]
	mov	eax,[.xy1]

;	 mov	 edx,[yres_var]
	cmp	ax,[yres_var]  ; SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	ror	eax,16

   ;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var] ;SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1
;------------------
	mov	eax,[.xy2]
 ;	 mov	 edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16
;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
	movzx	edx,[xres_var];SIZE_X
	ror	eax,16

	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	mov	eax,[.xy3]
      ;  mov	 edx,[yres_var]
	cmp	ax,[yres_var] ;dx ;SIZE_Y
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	ror	eax,16

    ;	 mov	 edx,[xres_var]
	cmp	ax,[xres_var] ;dx ;SIZE_X
	jge	.end_draw
	or	ax,ax
	jle	.end_draw

	movzx	ebx,ax
     ;	 mov	 edx,SIZE_X
	ror	eax,16
	cwde
	mul	edx
	add	eax,ebx
	shl	eax,2
	add	eax,edi
	mov	dword[eax],-1

	jmp   .end_draw
  .grd_line:		    ;****Gouraud line****
	fninit


	mov	esi,third_p_index
	mov	ecx,3
      .again_grd_line_param:
	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	mov	[ecx*4+col1-4],eax

	sub	 esi,4
	dec	 ecx			; decode all 3 edges
	jnz	 .again_grd_line_param


	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]

	mov	eax,[col1]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	mov	eax,[col2]
	movzx	bx,al
	push	bx		  ; b
	movzx	bx,ah
	push	bx
	rol	eax,16
	xor	ah,ah
	push	ax
	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	call	smooth_line	; draw only one edge

    jmp   .end_draw



  .tex_line:		    ;****textured line****



	cmp	[draw_flag],12
	je	@f

	fninit
	sub	esp,4
	mov	edx,[first_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff1
     @@:
	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]
     .pushzbuff1:
	push	word[zz1]

	mov	eax,[.xy1]
	ror	eax,16
	push	eax

	cmp	[draw_flag],12
	je	@f
	sub	esp,4
	mov	edx,[second_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[esp+2]
	jmp	.pushzbuff2
     @@:
	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]
     .pushzbuff2:

	push	[zz2]

	mov	 eax,[.xy2]
	ror	 eax,16
	push	 eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	mov	edx,envmap
	cmp	[draw_flag],12
	jne	@f
	mov	edx,texmap
     @@:
	call	tex_line     ; draw only one edge

    jmp   .end_draw

  .flat_line:		     ;****simple line****
			     ; without z coord. interpolation

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    or		eax,ecx
    test	eax,80008000h
    jne 	.end_draw

    mov 	eax,[.xy1]	; check if parameters exceedes screen area
    mov 	ecx,[.xy2]
    inc 	ax
    cmp 	ax,[yres_var] ;SIZE_Y
    jg		.end_draw
    inc 	cx
    cmp 	cx,[yres_var] ;SIZE_Y
    jg		.end_draw
    ror 	eax,16
    inc 	ax
    cmp 	ax,[xres_var] ;SIZE_X
    jg		.end_draw
    ror 	ecx,16
    inc 	cx
    cmp 	cx,[xres_var] ;SIZE_X
    jg		.end_draw

	movzx	 ebx,[xres_var]
	mov	 [screen_width_var],ebx ;,XRES

	mov	 eax,[.xy1]
    ;	 ror	  eax,16
	movzx	 ebx,ax
	shr	 eax,16
	mov	 ecx,[.xy2]
   ;	 ror	  ecx,16
	movzx	 edx,cx
	shr	 ecx,16

	push	 [screen_ptr]
	pop	 [lbuffer_ptr]

	call	 linea

	jmp	.end_draw


    .grd_tex:

	fninit

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov	esi,third_p_index
	mov	ecx,3

      .again_grd_tex_draw:

	mov	eax,[esi]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.x_temp_var]	 ; x temp variables
	fld	dword[eax+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	[.y_temp_var]

	mov	eax,[.y_temp_var]
	shl	eax,TEX_SHIFT
	add	eax,[.x_temp_var]
	lea	eax,[4*eax+color_map]
	mov	eax,dword[eax]
	push	word[ecx*2+zz1-2]


	ror	 eax,16 	      ; eax -0xxxrrggbb -> 0xggbbxxrr
	xor	 ah,ah
	push	 ax	    ;r
	rol	 eax,8		      ; eax-0xggbb00rr -> 0xbb00rrgg
	xor	 ah,ah
	push	 ax	    ;g
	shr	 eax,24
	push	 ax	    ;b

	sub	 esi,4
	dec	 ecx
	jnz	 .again_grd_tex_draw


	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,[Zbuffer_ptr]
	mov	edx,texmap

	call	tex_plus_grd_triangle

	jmp    .end_draw



     .flat_draw:		     ;**************************				     ; FLAT DRAWING
	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,[points_normals_rotated_ptr]
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,[points_normals_rotated_ptr]
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;	y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax

	mov	edi,[screen_ptr]
	mov	esi,[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	call	flat_triangle_z

    jmp   .end_draw






    .env_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,envmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


 .flat_draw_float:
    push  [.zz3f]
    push  [.zz2f]
    push  [.zz1f]

; calc color of triangle light vector dependent

	fninit
	push	eax
	push	ebx
	push	ecx

	mov	eax,[first_p_index]
	add	eax,[points_normals_rotated_ptr]
	fld	dword[eax]
	mov	ebx,[second_p_index]
	add	ebx,[points_normals_rotated_ptr]
	fadd	dword[ebx]
	mov	ecx,[third_p_index]
	add	ecx,[points_normals_rotated_ptr]
	fadd	dword[ecx]

	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.x_temp_var] ;[esp-4]    ; x temp variables
	fld	dword[eax+4]	; y cooficient of normal vector
	fadd	dword[ebx+4]
	fadd	dword[ecx+4]
	fidiv	[i3]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	dword[.y_temp_var];[esp-8]   ;	y
	mov	edx,[.x_temp_var]  ; dword[esp-8]
	shl	edx,TEX_SHIFT
	add	edx,[.y_temp_var] ;dword[esp-4]
	lea	eax,[4*edx+color_map]
	mov	edx,dword[eax]
	or	edx,0xff000000	 ; edx - color

	pop	ecx
	pop	ebx
	pop	eax



if 0
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index]
    call  dot_product
    fst   [.dpr]	    ; orginal+specular*st+emmisive*st^5
    push  ecx		    ; o + min*st + max * st^5
    mov   ecx,5 	    ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]	    ; dot product powered
    pop   ecx

    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxub    xmm3,[minimum0]
;    pminub    xmm3,[maximum255]
    packuswb  xmm3,xmm3
    movd      edx,xmm3
end if




    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]

    call  flat_triangle_z_float
    jmp     .end_draw
;end if

  .tex_mapping:
	push	[zz3]
	push	[zz2]
	push	word[zz1]
   ;  cmp    [hrt_flag],3	   ; check tetrahedron object cause
   ;  je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

    .no_tetra:
	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]   ; screen buffer
	mov	esi,texmap
	mov	edx,[Zbuffer_ptr]
	call	tex_triangle_z

	jmp	.end_draw


    .bump_mapping:
	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_triangle_z
	jmp    .end_draw

    .two_tex:		    ; double texture mapping

	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

   ;  cmp    [hrt_flag],3	   ; check tetrahedron object cause
   ;  je     @f

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]



	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,texmap

	call	two_tex_triangle_z
	jmp    .end_draw


    .bump_tex_mapping:

	mov    eax,[third_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; tex coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	push	texmap

	push	[Zbuffer_ptr]
	push	word[zz3]
	push	word[zz2]
	push	word[zz1]

	fninit
	xor	esi,esi
	sub	esp,12
	mov	edi,esp
	mov	[.counter],3
      @@:
	mov	edx,[esi+first_p_index]
	add	edx,[points_normals_rotated_ptr]    ;point_normals_rotated
	; texture x=(rotated point normal -> x * 255)+255
	fld	dword[edx]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi]
	; texture y=(rotated point normal -> y * 255)+255
	fld	dword[edx+4]
	fimul	[correct_tex]
	fiadd	[correct_tex]
	fistp	word[edi+2]

	add	edi,4
	add	esi,4
	dec	[.counter]
	jnz	@b

    ; cmp    [hrt_flag],3	   ; check tetrahedron object cause
    ; je     @f
	mov    eax,[third_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[second_p_index]	 ; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]

	mov    eax,[first_p_index]	; bump map coords
	cdq
	idiv   [i3]
	add    eax,[tex_points_ptr]
	push   dword[eax]




	mov    eax,[.xy1]
	mov    ebx,[.xy2]
	mov    ecx,[.xy3]

	mov	edi,[screen_ptr]
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING

	call	bump_tex_triangle_z


 .end_draw:

    popad
    pop   esi
    add   esi,6
;    cmp   dword[esi],-1
;    jnz   .draw_triangle
    pop    ecx
    dec    ecx
    jnz    .draw_triangle

    cmp  [hrt_flag],3	   ; write frame around current segment
    jl	 .no_rectangle
  @@:
    cmp  [current_seg],255
    jz	 .no_rectangle

    mov   esi,[points_rotated_ptr]
    movzx ebx,[current_seg]

    cmp   [hrt_flag],3
    jne   @f
    mov  eax,BSTEPS*BSTEPS*12
    jmp   .calc
  @@:
    cmp   [hrt_flag],4
    jne   @f
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]
    jmp   .calc
  @@:
    cmp   ebx,BPIPES ;-1
    jle   .only_pipes
    mov   eax,[rot_pipe_points_number]
    imul  eax,BPIPES*12
;    mul   edx
;    mov   ecx,ebx  ;[current_seg]
    sub   ebx,BPIPES
    imul  ebx,BSTEPS*BSTEPS*12
;  @@:
;    add   eax,BSTEPS*BSTEPS*12
;    loop  @b
    add    eax,ebx
    jmp   .skip_mul

  .only_pipes:
    mov   eax,[rot_pipe_points_number]
    shl   eax,2
    lea   eax,[eax*3]


 .calc:
    mul   ebx
 .skip_mul:
   add	 esi,eax
   movups xmm0,[esi]
   movups xmm1,[esi]
   add	  esi,12
   cmp	  [hrt_flag],3
   jg	  @f
   mov	  ecx,(BSTEPS*(BSTEPS))-1
   jmp	  .find
 @@:
   cmp	  [hrt_flag],4
   jg	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   cmp	  [current_seg],BPIPES
   jge	  @f
   mov	  ecx,[rot_pipe_points_number]
   dec	  ecx
   jmp	  .find
 @@:
   mov	  ecx,(BSTEPS*(BSTEPS))-1
 .find:
 @@:
   movups xmm2,[esi]
   maxps  xmm0,xmm2
   minps  xmm1,xmm2
   add	  esi,12
   sub	  ecx,1
   jnz	  @b
 ;  xmm0 - max
 ;  xmm1 - min
;   movss    xmm2,[scale]
;   shufps   xmm2,xmm2,0
;   mulps    xmm0,xmm2
;   mulps    xmm1,xmm2
 ;  cvtps2dq xmm0,xmm0
  ; cvtps2dq xmm1,xmm1
;   movdqu   xmm2,[xxadd]
;   paddd    xmm0,xmm2
;   paddd    xmm1,xmm2
   movups   xmm2,[max_clip_seg]
   movups   xmm3,[min_clip_seg]
   minps    xmm0,xmm2
   maxps    xmm1,xmm3
   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   movups   [cur_seg_max_rot],xmm0
   movups   [cur_seg_max_rot+12],xmm1



    ; max min coordinate should be normalized like whole object
    ; (witch is before rotating, rescaling and translating) in <-1.0 ; 1.0>


    .xsegmax equ [cur_seg_max_rot]
    .ysegmax equ [cur_seg_max_rot+4]
    .xsegmin equ [cur_seg_max_rot+12]
    .ysegmin equ [cur_seg_max_rot+16]

    movzx     eax,[xres_var]
    mov       [screen_width_var],eax ;,XRES




;    mov      eax,[cur_seg_max_rot+12]	 ; xmin
;    mov      ebx,[cur_seg_max_rot+16]	 ; ymin
;    mov      edx,ebx			 ; ymin
;    mov      ecx,[cur_seg_max_rot]	 ; xmax

    mov      ax,.xsegmin
    shl      eax,16
    mov      ax,.xsegmax
    mov      bx,.ysegmin
    shl      ebx,16
    mov      bx,.ysegmax

    push     [screen_ptr]
    pop      [lbuffer_ptr]
    call     write_frame

if 0
    mov     eax,[cur_seg_max_rot]      ; x max
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]	; x max
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea

    mov     eax,[cur_seg_max_rot]      ; x max
    inc     eax
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]	; x max
;    inc     ecx
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea


    mov     eax,[cur_seg_max_rot]      ; x max
    add     eax,2
    mov     ebx,[cur_seg_max_rot+16]   ; y min
;    mov     ecx,[cur_seg_max_rot]	; x max
;    add     ecx,2
    mov     ecx,eax
    mov     edx,[cur_seg_max_rot+4]    ; y max
    call    linea

    mov     eax,.xsegmin
    mov     ebx,.ysegmax
    mov     ecx,.xsegmax
    mov     edx,.ysegmax
    call    linea

    mov     eax,.xsegmin
    mov     ebx,.ysegmax
    mov     ecx,.xsegmin
    mov     edx,.ysegmin
    call    linea

    mov     eax,.xsegmin
    inc     eax
    mov     ebx,.ysegmax
;    mov     ecx,.xsegmin
;    inc     ecx
    mov     ecx,eax
    mov     edx,.ysegmin
    call    linea

    mov     eax,.xsegmin
    add     eax,2
    mov     ebx,.ysegmax
;    mov     ecx,.xsegmin
;    add     ecx,2
    mov     ecx,eax
    mov     edx,.ysegmin
    call    linea
end if
 @@:
   .no_rectangle:
    popad

   ; invoke	 MessageBox,[hwnd],STRdata,_tsc_title,MB_RTLREADING
;   invoke stop_ticks
ret

endp

normalize_all_light_vectors:
	mov	edi,lights
     @@:
	call	normalize_vector	   ;	   3dmath.inc
	add	edi,LIGHT_SIZE
	cmp	edi,lightsend	;ecx
	jl	@b
ret
read_hrt:
	fninit
	mov    esi,hrt_triangles
	mov    edi,[triangles_ptr]
	cld
	mov    [triangles_count_var],hrt_triangles_count
	mov    ecx,hrt_triangles_count
     @@:
	movsd
	movsw
	loop   @b
	movsd	    ; copy end mark too


	mov    esi,hrt_points
	mov    edi,[points_r_ptr]
	mov    [points_count_var],0
      @@:
	fild   word[esi]
	fstp   dword[edi]
	fild   word[esi+2]
 ;	 fchs
	fstp   dword[edi+4]
	fild   word[esi+4]
	fstp   dword[edi+8]
	inc    [points_count_var]
	add    edi,12
	add    esi,6
	cmp    dword[esi],-1
	jne    @b
	movsd	 ;copy	end mark too

ret
alloc_mem_for_tp:
     cmp     [tp_mem_alloc],1	   ; cmp triangulize cause
     jne     @f
     call    free_mem_for_tp
     jmp     .no_tp
  @@:
     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_r_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [shadow_vertices_ptr],eax



     movzx   eax,[triangles_count_var]
     imul    eax,[i6]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [triangles_ptr],eax
 .no_tp:
     movzx   eax,[triangles_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [triangles_normals_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_normals_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_normals_rotated_ptr],eax

     movzx   eax,[points_count_var]
     imul    eax,[i12]
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [points_rotated_ptr],eax

     movzx   eax,[points_count_var]
     shl     eax,2
     add     eax,20
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [tex_points_ptr],eax
ret
free_mem_for_tp:
   cmp	   [tp_mem_alloc],1    ; check triangulize cause
   je	   .no_tp
   mov	   ebx,[points_r_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

 ;    movzx   edx,[points_count_var]
 ;    imul    edx,[i12]
 ;    add     edx,20
     mov     ebx,[shadow_vertices_ptr]
     invoke  VirtualFree, ebx , 0,  MEM_RELEASE
     or  eax,eax
     jnz @f
  ;   int3
   @@:



   mov	   ebx,[triangles_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:
 .no_tp:
   mov	   ebx,[triangles_normals_ptr]
   movzx   eax,[triangles_count_var]
   imul    eax,[i12]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

   mov	   ebx,[points_normals_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
 ;  int3
 @@:

   mov	   ebx,[points_normals_rotated_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
 ;  int3
 @@:

   mov	   ebx,[points_rotated_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

   mov	   ebx,[tex_points_ptr]
   invoke  VirtualFree, ebx , 0,  MEM_RELEASE
   or	   eax,eax
   jnz	   @f
;   int3
 @@:

ret

read_tp_variables:	      ; read [triangles_count_var] and ...
			      ; ..[points_count_var]
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],bx
	mov	[triangles_count_var],bx
	mov	esi,[File_ptr]


	cmp	[esi],word 4D4Dh
	je	@f ;Must be legal .3DS file
	xor	eax,eax
	ret
    @@:
	mov	eax,dword[esi+2]
	cmp	eax,[FileSize] ;This must tell the length
	je	@f
	xor	eax,eax
	ret
     @@:
	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:

	add	ebx,6
	add	esi,12
     ;	 dec	 ecx
	loop	 @b
      @@:

      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8

      @@:
	add	esi,8
	dec	ecx
	jnz	@b
;	 xor	 ecx,ecx
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
ret


read_from_file:   ;; this procedure coded orginally by Madis Kalme
	fninit
    ;	 mov	 edi,[triangles_ptr]
	mov	edi,[triangles_ptr]
	xor	ebx,ebx
	xor	ebp,ebp
	mov	[points_count_var],0
	mov	[triangles_count_var],0

	mov	esi,[File_ptr]

	cmp	[esi],word 4D4Dh
	jne	.exit ;Must be legal .3DS file
;	 cmp	 dword[esi+2],EndFile-SourceFile
;	 jne	 .exit ;This must tell the length
	mov	eax,dword[esi+2]
  ;	 cmp	 eax,[fsize]
  ;	 jne	 .exit

	add	eax,esi
	mov	[EndFile],eax	 ;

	add	esi,6
      @@:
	cmp	[esi],word 3D3Dh
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      .find4k:
	cmp	[esi],word 4000h
	je	@f
	add	esi,[esi+2]
	cmp	esi,[EndFile]
	jc	.find4k
	jmp	.exit
      @@:
	add	esi,6
      @@:
	cmp	[esi],byte 0
	je	@f
	inc	esi
	jmp	@b
      @@:
	inc	esi
      @@:
	cmp	[esi],word 4100h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	add	esi,6
      @@:
	cmp	[esi],word 4110h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[points_count_var],cx

	mov	edx,ecx
	add	esi,8
     @@:
	push	edi
	mov	edi,[points_r_ptr]
	push	dword[esi+0]
	pop	dword[edi+ebx*2+0]
	push	dword[esi+4]
	pop	dword[edi+ebx*2+4]
	push	dword[esi+8]
	pop	dword[edi+ebx*2+8]
	pop	edi

	add	ebx,6
	add	esi,12
	dec	ecx
	jnz	@b
      @@:
  ;	 mov	 dword[points+ebx],-1
	push	edi
    ;	 mov	 edi,[points_ptr]
	mov	edi,[points_r_ptr]
	mov	dword[edi+ebx*2],-1	   ; end mark (not always in use)
	pop	edi
      @@:
	cmp	[esi],word 4120h
	je	@f
	add	esi,[esi+2]
	jmp	@b
      @@:
	movzx	ecx,word[esi+6]
	add	[triangles_count_var],cx
	add	esi,8
	;mov	 edi,[triangles_ptr]
      @@:
	movsd
	movsw
	add	word[edi-6],bp
	add	word[edi-4],bp
	add	word[edi-2],bp
	add	esi,2
	dec	ecx
	jnz	@b
	add	ebp,edx
	jmp	.find4k
	mov	eax,-1 ;<---mark if OK
      .exit:
	mov	dword[edi],-1
ret

init_triangles_normals2:
	fninit
	mov	ebx,[triangles_normals_ptr]
	mov	ebp,[triangles_ptr]
	movzx	ecx,[triangles_count_var]
     @@:
	push	ecx
	push	ebx
	mov	ebx,vectors
	movzx	esi,word[ebp]	       ; first point index
	lea	esi,[esi*3]
    ;	 lea	 esi,[points+esi*2]	; esi - pointer to 1st 3d point
	shl	esi,2
	add	esi,[points_r_ptr]
	movzx	edi,word[ebp+2] 	 ; first point index
	lea	edi,[edi*3]
	shl	edi,2
  ;	 add	 edi,[points_ptr]
	add	edi,[points_r_ptr]
;	 movzx	 edi,word[ebp+2]	; second point index
;	 lea	 edi,[edi*3]
;	 lea	 edi,[points+edi*2]	; edi - pointer to 2nd 3d point

	call	make_vector_r
	add	ebx,12
	mov	esi,edi
	movzx	edi,word[ebp+4]        ; third point index
	lea	edi,[edi*3]
	shl	edi,2
      ;  add	 edi,[points_ptr]
	add	edi,[points_r_ptr]
;	 lea	 edi,[points+edi*2]
	call	make_vector_r
	mov	edi,ebx 		; edi - pointer to 2nd vector
	mov	esi,ebx
	sub	esi,12			; esi - pointer to 1st vector
	pop	ebx
	call	cross_product
	mov	edi,ebx
	call	normalize_vector
	add	ebp,6
	add	ebx,12
	pop	ecx
	loop	@b
    ;	 cmp	 dword[ebp],-1
      ;  jne	 @b
ret

init_point_normals:
.x equ dword [ebp-4]
.y equ dword [ebp-8]
.z equ dword [ebp-12]
.point_number equ word [ebp-26]
.hit_faces    equ word [ebp-28]

	fninit
	mov	  ebp,esp
	sub	  esp,28
	mov	  edi,[points_normals_ptr] ;[points_normals_ptr]
	mov	  .point_number,0
    .ipn_loop:
	mov	  .hit_faces,0
	mov	  .x,0
	mov	  .y,0
	mov	  .z,0
	mov	  esi,[triangles_ptr];[triangles_ptr]
	xor	  ecx,ecx	       ; ecx - triangle number
    .ipn_check_face:
	xor	  ebx,ebx	       ; ebx - 'position' in one triangle
    .ipn_check_vertex:
	movzx	  eax,word[esi+ebx]    ;  eax - point_number
	cmp	  ax,.point_number
	jne	  .ipn_next_vertex
	push	  esi
	mov	  esi,ecx
	lea	  esi,[esi*3]
       ; lea	   esi,[triangles_normals+esi*4]
	shl	  esi,2
	add	  esi,[triangles_normals_ptr];[triangles_normals_ptr]

	fld	  .x
	fadd	  dword[esi]
	fstp	  .x
	fld	  .y
	fadd	  dword[esi+4]
	fstp	  .y
	fld	  .z
	fadd	  dword[esi+8]
	fstp	  .z
	pop	  esi
	inc	  .hit_faces
	jmp	  .ipn_next_face
    .ipn_next_vertex:
	add	  ebx,2
	cmp	  ebx,6
	jne	  .ipn_check_vertex
    .ipn_next_face:
	add	  esi,6
	inc	  ecx
	cmp	  cx,[triangles_count_var]
	jne	  .ipn_check_face

	fld	  .x
	fidiv	  .hit_faces
	fstp	  dword[edi]
	fld	  .y
	fidiv	  .hit_faces
	fstp	  dword[edi+4]
	fld	  .z
	fidiv	  .hit_faces
	fstp	  dword[edi+8]
	call	  normalize_vector
	add	  edi,12  ;type vector 3d
	inc	  .point_number
	mov	  dx,.point_number
	cmp	  dx,[points_count_var]
	jne	  .ipn_loop

	mov	  esp,ebp
ret


draw_menu:
   ;draw menu
;    mov    edi,menu_screen
;    cld
;    mov    ecx,MXRES*MYRES
;    xor    eax,eax
;    rep    stosd

    mov    [screen_width_var],MXRES
    mov    [lbuffer_ptr],menu_screen
    mov    [line_color],0x0000ff00
    mov    esi,menu_data
  .lab:
    push  esi

    mov   ax,[esi+2]
    shl   eax,16
    mov   ax,[esi+6]
    mov   bx,[esi+4]
    shl   ebx,16
    mov   bx,[esi+8]
    push  esi
    call  write_frame
    pop   esi



    mov   eax,[esi+2]	   ; write button desc
    ror   eax,16
    add   eax,0x00030000
    mov   ebx,font_table + 62
    mov   ecx,MXRES shl 16 + MYRES
    add   esi,10
    mov   edi,menu_screen
    pushad
    call  write_text
    popad

    add   eax,90 shl 16 + 0	 ; write flag of button
    cmp   dword[esi+13],-1
    je	  @f
    movzx edi,byte[esi+12]
    imul  edi,[i5]
    mov   esi,[esi+13]
    add   esi,edi
    mov   edi,menu_screen
    call  write_text
   @@:

    pop   esi
    add   esi, 33
    cmp   word[esi],-1
    jne   .lab


    movzx    eax,[whole_xres]
    mov      ecx,eax
    sub      eax,MXRES
  ;  invoke BitBlt,[hdc],eax,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY
    invoke StretchDIBits,[hdc],eax,0,MXRES,MYRES,0,0,MXRES,MYRES,menu_screen,Mbmi,0,SRCCOPY
ret

random_point_light_position:
if 1
  rdtsc
  mov	   [rand_seed],ax
  xor	   ebx,ebx
 @@:
  push	   ebx
  mov	   ecx, -1000
  mov	   edx, 1000
  call	   random
  cvtsi2ss xmm0,eax
  pop	   ebx
  movss    [point_light_coords+ebx],xmm0
  add	   ebx,4
  cmp	   ebx,8
  jnz	   @b
end if
if 1
  xor	   ebx,ebx
  mov	   eax,255
  cvtsi2ss xmm1,[i255d]  ;eax
 @@:
  push	   ebx
  mov	   ecx, 0
  mov	   edx, 255
  call	   random
  cvtsi2ss xmm0,eax
  divss    xmm0,xmm1
  pop	   ebx
  movss    [plane_equation+ebx],xmm0
  add	   ebx,4
  cmp	   ebx,8
  jnz	   @b
end if
ret



include 'grd_cat.inc'
include 'tex_cat.inc'
include 'flat_cat.inc'
if Ext >= AVX
  include 'flat_cat_floatZavx.inc'
else
  include 'flat_cat_floatZ.inc'
end if
include '3DMATH.INC'
include 'procs_a.inc'
include 'bump_cat.inc'
include 'bump_tex.inc'
include 'two_tex.inc'
include 'grd_tex.inc'
include 'grd_line.inc'
include 'tex_line.inc'
include 'line.inc'
include  'shd3.inc'

include 'b_curve.inc'
;include 'Bline.inc'
include 'arbitrary_vector.inc'
include 'matrix.inc'
include 'rotated_bezier.inc'
;include 'b_surface.inc'
include 'asc.inc'
include 'asc_header.inc'
include 'menu.inc'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class     TCHAR	 'grtest',0
    _title     TCHAR	 'Ave Cruce Salus Mea'
  if Ext = SSE2
     .exxt     TCHAR	 ' SSE2'
  else if Ext = SSE3
     .exxt     TCHAR	 ' SSE3'
  else if Ext = SSE4.1
     .exxt     TCHAR	 ' SSE4.1'
  else if Ext = AVX
     .exxt     TCHAR	 ' AVX'
  end if
  fakebitmap   dd  0,0,0,0
    .end TCHAR 0
    _error     TCHAR	 'Startup failed.',0
    _tsc_title TCHAR	 'Clocks number',0
    sh_model   TCHAR	 'Nodes of object                     '
	.fl    TCHAR	 'Flat Shading                        '
	.gr    TCHAR	 'Gouraud Shading                     '
	.sp    TCHAR	 'Spherical Environment Mapping       '
	.bm    TCHAR	 'Bump Mapping                        '
	.tx    TCHAR	 'Texture Maping                      '
	.grtx  TCHAR	 'Gouraud Shading and Texture Mapping '
	.dtxx  TCHAR	 'Double Texture Mapping              '
	.bmtx  TCHAR	 'Bump and Texture Mapping Pararell   '
	.grl   TCHAR	 'Gouraud Shaded Line                 '
	.flf   TCHAR	 'Flat Shading with Float zBuffer     '
	.txl   TCHAR	 'Textured Line - Env. Mapping        '
	.tx12  TCHAR	 'Textured Line                       '
	.line  TCHAR	 'Simple line without z coord. interp.'
	.shad  TCHAR	 'Shadow + spot light                 '
  ;  menu_text	db	  '@ABCDEFGHIJKLMNO',0
  ;  mt2	db	  'PQRSTUVWXYZ[/]^_',0
  ;  mt3	db	  'menu programu win3ds! 0123',0
;    no_display  dw 11	  ; Number of displaying models    '

    File_ptr	 dd ?
    File_tex_ptr dd ?
    SourceFile:
;    file	 'knot.3ds'
    EndFile	dd ?
    asc_file_name db 'object.asc'
    up		dd 0
    s_time	dd 0
    e_time	dd 0
    num_animations dd 3
    ccounter	   dd 0

    screen_width_var dd ?  ; SIZE_X
    triangles_count_var  dw TRIANGLES_COUNT
    points_count_var	 dw POINTS_COUNT

    convert_muler:
    dd 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000
    XYZpartices:
    db 'X','Y','Z'
    i10 dw 10




    tex_x_div2	dd  TEX_X / 2
    tex_y_div2	dd  TEX_Y / 2
    i3		dd  3
    i2		dd  2
    i5		dd  5
    i6		dd  6
    i9		dd  9
    i12 	dd  12
    i24 	dd  24
    i36 	dd  36
    i38 	dd  38
    i180	dw  180
    i256	dw  256
    i255d	dd  255
    f1		dd  1.0
    env_const	dd  1.05
    dot_max	dd  1.0
    dot_min	dd  0.0
    correct_tex dw  255
    displac_div dd  5800 ;* 3 ; displacement divisior
    plane_equation:
     .A dd 0.5
     .B dd 0.5
     .C dd 1.0
     .D dd 0.0

    scale	dd 200.0
    scale_plus	dd 1.2
    scale_minus dd 0.8
    line_color	dd 0x0000ff00
    xxadd:
		dd   ?	;XRES/2
    yyadd	dd   ?	;YRES/2
    zzadd	dd 0
		dd 0
    seg_rot_flag_button_down db 0
    tex_button_pres	     db 0
    tp_mem_alloc	     db 0
    current_seg_add_flag     db 0
 ;   draw_flag	 db 1
;    blur_flag	 db 0
;    hrt_flag	 db 0
  ;  map_flag	 db 0
  ;  bump_flag	 db 0
 ;   tex_flag	 db 0
  ;  rotary_flag db 0
;    lbuffer_ptr dd buffer
    piD128:
    one_deg	dd   0.024543692
    STRdata	db   '-1        '
    main_rotary :
	       dd 0
	       dd 0
	       dd 0
    all_lights_size dw lightsend-lights
if 0
;   color of point light is color of first directional light
  point_light:
  ;  .vec	 dd -0.5, 0.4, -1.0
    p_light_max:
		dw 210,220,255,0
    p_light_o:
		dw 30,15,8,0
    p_light_min:
		dw 137,88,120,0
end if
    align 16
    point_light_coords:
	      dd -500.0
	      dd -500.0
	      dd -900.0
	      dd 0.0




  lights:

    light_vect	    dd	 0.0,0.0,-1.0
    light_c_o:			     ; +12
    p_light_o:
		    dw	 51,71,11,0
    light_c_min:		     ; +20
    p_light_min:
		    dw	 15,99,17,0
    light_c_max:
    p_light_max:
		    dw	 255,255,5,0 ; +28
    shiness:
		    dw	 5	     ; +36
    LIGHT_SIZE = ($-lights)

	dd   -0.5,-0.5,-1.0
				    ;	+12
	dw   1,255,1,0
				    ;	+20
	dw   1,1,1,0
				    ;	+28
	dw   255,255,255,0
	dw   5			    ;	+36



       dd   0.5,0.5,-1.0
				   ;   +12
       dw   13,1,1,0
				   ;   +20
       dw   70,30,70,0
				   ;   +28
       dw   25,255,255,0
       dw   5			   ;   +36
   lightsend:


 align 16
    minimum0:
       dw   0,0,0,0,0,0,0,0
    maximum255:
       dw   255,255,255,255,255,255,255,255
 align 16
    mask_blend:
       dd -1,-1,-1,-1
    tex_cutter:
       dd TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE, TEXTURE_SIZE
    blur_sub:
       dd 0x01010101, 0x01010101, 0x01010101, 0x01010101
 align 16
    muler1234:
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
align 16
    muler0_7:
    muler0123:
       dd 0.0
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
       dd 5.0
       dd 6.0
       dd 7.0
mask_255f:
       dd 255.0, 255.0, 255.0, 255.0
align 16
mask_line:
	   dq 0xffffffff00ffffff
	   dq 0xffffffffffffffff
zero_hgst_dd:
	   dd 0xffffffff, 0xffffffff, 0xffffffff, 0x00000000
one_hgst_dd:
	   dd 0.0, 0.0, 0.0, 1.0

filter	   TCHAR   '3ds objects (*.3ds)',0,'*.3ds',0,\
		   'asc objects (*.asc)',0,'*.asc',0,\
		   'All files (*.*)',0,'*.*',0,0
_not3ds    TCHAR   'Not an 3d object file or read error.',0
_notraw    TCHAR   'Not an RAW 512X512 file or read error.',0
filter_tex TCHAR   'raw file 512X512 (*.raw)',0,'*.raw',0,\
		   'All files (*.*)',0,'*.*',0,0






; Sanctssimi Cordis Christi section
   hrt_points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

	hrt_points_count = ($-hrt_points)/6
dd -1
    hrt_triangles:
dw 1,0,12, 2,1,12, 9,8,12, 10,9,12, 11,10,12, 0,11,12, 12,13,2, 13,12,8, 3,2,13
dw 4,3,13, 5,4,13, 6,5,13, 7,6,13, 8,7,13
;crux
dw 22,21,23, 24,23,21, 25,24,14, 14,24,18, 18,24,20, 19,18,20, 16,15,18
dw 17,16,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38, 37,26,38, 38,39,34, 28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 39,38,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,44, 50,42,44
dw 42,43,44, 46,50,44, 44,45,46
;border cordis
dw 0,1,26, 1,27,26, 1,2,27, 28,27,2, 2,3,28, 29,28,3, 3,4,29, 30,29,4, 4,5,30
dw 31,39,5, 5,6,31, 32,31,6, 6,7,32, 33,32,7, 7,8,33, 34,33,8, 8,9,34, 35,34,9
dw 9,10,35, 36,35,10, 10,11,36, 37,36,11, 11,0,37, 37,26,0, 0,38,37
;border crux
dw 14,15,40, 41,40,15, 15,16,41, 42,41,16, 16,17,42, 43,42,17, 17,18,43
dw 44,43,18, 18,19,44, 45,44,19, 19,20,45, 46,45,20, 20,21,46, 47,46,21
dw 21,22,47, 48,47,22, 23,24,49, 50,49,24, 24,25,50, 51,50,25, 25,14,51
dw 14,40,51
;crown
dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
	hrt_triangles_count = ($-hrt_triangles)/6
dd -1
;box


tetra_points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
tetra_points_count = 4
dd -1 ;<- end marker

tetra_triangles:
dw 0,1,2, 2,3,0, 2,1,3,  1,0,3
tetra_triangles_count = 4
dd -1 ;<- end marker
tetra_tex_points:
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dd -1
current_seg db 0      ; 255 - no segment selected
;segments_rotary:
;    dd 0  ; x ; angles (in degrees) rotary single Bezier segment
;    dd 0  ; y
;    dd 0  ; z
max_clip_seg:
    dd ?  ;XRES - 3
    dd ?  ;YRES - 3
min_clip_seg:
    dd 1.0
    dd 1.0
current_seg_add:
    dd 0       ; x ,y ,z
    dd 0
    dd 0
current_seg_add_start:
    dd 0
    dd 0
    dd 0
seg_backward_rot:
    dd 0
    dd 0
    dd 0
maxscaleseg dd 1.0
allsegcenter:
    dd 0, 0, 0, 0
rot_pipe_points_number dd  0

include  'b_rot_var_init.inc'

font_table:
file 'font8x16.bmp'
;include  'b_surface_data.inc'
if 1
;menu_button_pressed db 0
menu_button_number  dw 0
menu_data:

	       dw 0		   ; mark if button chosen
	       dw 2		   ; x1
	       dw 2		   ; y1
	       dw 85		   ; x2
	       dw 20		   ; y2
	       db 'rotary    ',0   ; label
	       db 3		   ; max flag  + 1 , if = 255, no flag
  rotary_flag  db 0		   ; flag
	       dd axl_f 	   ; offset to flags description
	       dw 1		   ; button number
	       dw VK_F12	   ; key 1
	       dw 0		   ; key 2 if '0' - none

	       dw 0
	       dw 2		   ; x1
	       dw 22		   ; y1
	       dw 85		   ; x2
	       dw 40
	       db 'mot. blur ',0
	       db 2
   blur_flag   db 1
	       dd on_of_f
	       dw 2
	       dw VK_F1
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 42		   ; y1
	       dw 85		   ; x2
	       dw 60
	       db 'zoom in   ',0
	       db 2
  zoom_in_flag db 0
	       dd -1		  ; if 0xffffffff - no flag desc
	       dw 3
	       dw VK_F3
	       dw VK_ADD

	       dw 0
	       dw 2		   ; x1
	       dw 62		   ; y1
	       dw 85		   ; x2
	       dw 80
	       db 'zoom out  ',0
	       db 2
 zoom_out_flag db 0
	       dd -1
	       dw 4
	       dw VK_F4
	       dw VK_SUBTRACT

	       dw 0
	       dw 2		   ; x1
	       dw 82		   ; y1
	       dw 85		   ; x2
	       dw 100
	       db 'tex. mapp.',0
	       db 4
    map_flag   db 0
	       dd tex_map_f
	       dw 5
	       dw VK_F5
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 102		    ; y1
	       dw 85		   ; x2
	       dw 120
	       db 'ran. light',0
	       db 2
       rd_flag db 0
	       dd -1
	       dw 6
	       dw VK_TAB
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 122		    ; y1
	       dw 85		   ; x2
	       dw 140
	       db 'dr. model ',0
	       db 15
     draw_flag db 14
	       dd -1
	       dw 7
	       dw VK_SPACE
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 142		    ; y1
	       dw 85		   ; x2
	       dw 160
	       db 'bumps     ',0
	       db 2
     bump_flag db 0
	       dd bumps_f
	       dw 8
	       dw VK_F6
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 162		    ; y1
	       dw 85		   ; x2
	       dw 180
	       db 'texture   ',0
	       db 3
     tex_flag  db 0
	       dd tex_f
	       dw 9
	       dw VK_F7
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 182		    ; y1
	       dw 85		   ; x2
	       dw 200
	       db 'save obj. ',0
	       db 2
     sav_flag  db 0
	       dd -1
	       dw 10
	       dw VK_F8
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 202		    ; y1
	       dw 85		   ; x2
	       dw 220
	       db 'run / stop',0
	       db 2
  ccounter_inc db 1
	       dd run_st_f
	       dw 11
	       dw VK_F11
	       dw 0

	       dw 0
	       dw 2		   ; x1
	       dw 222		    ; y1
	       dw 85		   ; x2
	       dw 240
	       db 'cur.segm. ',0
	       db 2 ;BSEGMENTS
	       db 0
	       dd -1
	       dw 12
	       dw VK_F9
	       dw 0

;		dw 0
;		dw 130		      ; x1
;		dw 2		   ; y1
;		dw 212		     ; x2
;		dw 20
;		db 'load tex. ',0
;		db 2
;		db 0
;		dd -1
;		dw 13
;		dw 0x58 	 ; x
;		dw 0

	       dw 0
	       dw 130		     ; x1
	       dw 2		  ; y1
	       dw 212		    ; x2
	       dw 20
	       db 'do displ. ',0      ; displacement
	       db 2
	       db 0
	       dd -1
	       dw 13
	       dw 0x44		; D
	       dw 0

	       dw 0
	       dw 130		     ; x1
	       dw 22		   ; y1
	       dw 212		    ; x2
	       dw 40
	       db 'do triang.',0
	       db 2
	       db 0
	       dd -1
	       dw 14
	       dw 0x54		; T
	       dw 0

	       dw 0
	       dw 130		    ; x1
	       dw 42		    ; y1
	       dw 212		    ; x2
	       dw 60		    ; y2
	       db 'cur object',0
	       db 6
      hrt_flag db 0
	       dd cur_obj_f
	       dw 15
	       dw VK_F2
	       dw 0

if 1
	       dw 0		   ; mark if button chosen
	       dw 130		   ; x1
	       dw 62		   ; y1
	       dw 212		   ; x2
	       dw 80		   ; y2
	       db 'rand. shd.',0   ; label
	       db 255		   ; max flag  + 1 , if = 255, no flag
    xchg_flag  db 0		   ; flag
	       dd -1		   ; offset to flags description
	       dw 16		   ; button number
	       dw 0x55		   ; key 1
	       dw 0		   ; key 2 if '0' - none

end if
	       dw -1  ; <- end flag

end if
cur_obj_f:
     db 'file',0
     db 'hrt ',0
     db 'tetr',0
     db 'r.s.',0
     db 'pipe',0
     db 'r.sp',0

tex_map_f:
     db 'p.xy',0
     db 'p.xz',0
     db 'p.yz',0
     db 'sph.',0

axl_f:
     db 'y   ',0
     db 'x   ',0
     db 'z   ',0
on_of_f:
     db 'on  ',0
     db 'off ',0
bumps_f:
     db 'rand',0
     db 'tex ',0
tex_f:
     db 'str.',0
     db 'xor ',0
     db 'none',0
run_st_f:
    db	'stop',0
    db	'run ',0
 ;   surface_equation:
 ;   .A  dd 0.0
 ;   .B  dd 0.0
 ;   .C  dd 1.0
 ;   .D  dd 5500.0
 ;   light:
 ;   .lx dd -200
 ;   .ly dd -200
 ;   .lz dd -200
    msg     MSG
    rect    RECT
    ofn     OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fname,260 ;MAXSIZE
    ofntex  OPENFILENAME sizeof.OPENFILENAME,0,0,filter_tex,0,0,0,fnametex,260 ;MAXSIZE
    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class
    ps PAINTSTRUCT

      ; single pipe points count
    whole_xres	    dw ?
    whole_yres	    dw ?
    xres_var	    dw ?
    yres_var	    dw ?
    mwxres	    dw ?
    mwyres	    dw ?
    screen_ptr	    dd ?
    Zbuffer_ptr     dd ?
    line_buffer_var dd ?
    heap_start_ptr  dd ?
    lbuffer_ptr     dd ?
    points_r_ptr    dd ?
    triangles_ptr   dd ?
    shd_buffer_ptr  dd ?
    triangles_normals_ptr      dd ?
    points_normals_ptr	       dd ?
    points_normals_rotated_ptr dd ?
    points_rotated_ptr	       dd ?
    tex_points_ptr	       dd ?  ; bump_map  and texture coords
				    ; each point word x, word y
    shadow_vertices_ptr        dd ?
    p_light_vec:
	      rd 12
    shd_counter dd ?
 ;   point_light_coords:
 ;	       rd 4
    segments_add:
	      rd BSEGMENTS*3
    segments_rotary:
	      rd BSEGMENTS*3	; x ; angles (in degrees) rotary single Bezier segment
  ;  cur_seg_max:	; current edited (rotary) bezier segment min and max coordinate
  ;	       rd 3
  ;  cur_seg_min:
  ;	       rd 3
  ;	       rd 1   ; 4 byte space
    cur_seg_max_rot:
	      rd 8
    cur_seg_center:
	      rd 4
    center_scale:
	      rd 4
    max_scale dd ?
;    temp_vect:
;	       rd 4
    tex_mov_begin_x:
		     dw ? ;  \ dont change order
    tex_mov_begin_y  dw ? ;  /
    file_ext_flag    db ?   ; 0 - 3ds, 1 - asc
    fname     rb     260 ;MAXSIZE
    fnametex  rb     260
    BytesRead dd ?
    hfile     dd ?
    hfiletex  dd ?
    FileSize  dd ?
    byteswritten  dd ?
    hheap	  dd ?
    pmem	  dd ?
    pmemtex	  dd ?
    first_p_index:
		   dd ?
    second_p_index dd ?
    third_p_index  dd ?   ; don't change order
align 16
    cos_x:
		  rd 1
    sin_x	  dd ?
    neg_cos_x	  dd ?
    neg_sin_x	  dd ?
;align 16
    cos_y:
		  rd 1
    sin_y	  dd ?
    neg_cos_y	  dd ?
    neg_sin_y	  dd ?
;align 16
    cos_z:
		  rd 1
    sin_z	  dd ?
    neg_cos_z	  dd ?
    neg_sin_z	  dd ?

    rand_seed dw ?
    hwnd      dd ?
    hdc       dd ?
    bmi       BITMAPINFOHEADER
    Mbmi      BITMAPINFOHEADER
    align 16
    sse_repository:
       rd 512
  align 16
    bump_map  rb TEX_X * TEX_Y
    envmap    rd TEX_X * TEX_Y
    color_map rd TEX_X * TEX_Y
    texmap    rd TEX_X * TEX_Y
    menu_screen rd MXRES * MYRES

    hrt_points_r:
       rb 65536



    col1:
		   dd ?
    col2	   dd ?
    col3	   dd ?
    zz1:
		   dw ?
    zz2 	   dw ?
    zz3 	   dw ? ;-> don't change order

    vectors rb 24
    angles  rb 24
    matrix  rb 36
    cos_tab rd 360
    sin_tab rd 360
include  'b_rot_var_uninit.inc'


section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM',\
    comdlg32,'COMDLG32'    ;   timing,'timing.dll'
    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'
    include '\include\api\comdlg32.inc'
 ;   include 'timing.inc'
;    import winmm,timeGetTime,'timeGetTime'




